import { PropsWithChildren } from 'react';
import { Severity } from 'src/types';
import { FillLevel } from './contexts/FillLevelContext';
import { ButtonProps } from './Button';
declare const SEVERITIES: readonly ["info", "danger", "warning", "success"];
export declare type CalloutSeverity = Extract<Severity, typeof SEVERITIES[number]>;
export declare type CalloutSize = 'compact' | 'full';
export declare type CalloutProps = PropsWithChildren<{
    title?: string;
    severity?: CalloutSeverity;
    size?: CalloutSize;
    buttonProps?: ButtonProps;
    fillLevel?: FillLevel;
    className?: string;
}>;
export declare function CalloutButton(props: ButtonProps): JSX.Element;
declare const Callout: import("react").ComponentType<{
    title?: string;
    severity?: CalloutSeverity;
    size?: CalloutSize;
    buttonProps?: ButtonProps;
    fillLevel?: FillLevel;
    className?: string;
} & {
    children?: import("react").ReactNode;
} & import("react").RefAttributes<HTMLDivElement>>;
export default Callout;
