var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { Div } from 'honorable';
import { forwardRef, useMemo } from 'react';
import { styledTheme as theme } from '../theme';
import { FillLevelProvider, isFillLevel, toFillLevel, useFillLevel, } from './contexts/FillLevelContext';
const fillLevelToBGColor = {
    0: 'fill-one',
    1: 'fill-one',
    2: 'fill-two',
    3: 'fill-three',
};
const fillLevelToBorderColor = {
    0: 'border',
    1: 'border',
    2: 'border-fill-two',
    3: 'border-fill-three',
};
const fillLevelToHoverBGColor = {
    0: 'fill-one-hover',
    1: 'fill-one-hover',
    2: 'fill-two-hover',
    3: 'fill-three-hover',
};
const hueToFillLevel = {
    default: 1,
    lighter: 2,
    lightest: 3,
};
const fillLevelToSelectedBGColor = {
    0: 'fill-one-selected',
    1: 'fill-one-selected',
    2: 'fill-two-selected',
    3: 'fill-three-selected',
};
const cornerSizeToBorderRadius = {
    medium: 'medium',
    large: 'large',
};
function useDecideFillLevel({ hue, fillLevel, }) {
    const parentFillLevel = useFillLevel();
    if (isFillLevel(fillLevel)) {
        fillLevel = toFillLevel(Math.max(1, fillLevel));
    }
    else {
        fillLevel = hueToFillLevel[hue];
    }
    const ret = useMemo(() => (isFillLevel(fillLevel) ? fillLevel : toFillLevel(parentFillLevel + 1)), [fillLevel, parentFillLevel]);
    return ret;
}
const Card = forwardRef((_a, ref) => {
    var { cornerSize: size = 'large', hue, // Deprecated, prefer fillLevel
    fillLevel, selected = false, clickable = false } = _a, props = __rest(_a, ["cornerSize", "hue", "fillLevel", "selected", "clickable"]);
    fillLevel = useDecideFillLevel({ hue, fillLevel });
    return (_jsx(FillLevelProvider, Object.assign({ value: fillLevel }, { children: _jsx(Div, Object.assign({ ref: ref, border: `1px solid ${fillLevelToBorderColor[fillLevel]}`, borderRadius: cornerSizeToBorderRadius[size], backgroundColor: selected
                ? fillLevelToSelectedBGColor[fillLevel]
                : fillLevelToBGColor[fillLevel] }, (clickable && {
            cursor: 'pointer',
        }), (clickable
            && !selected && {
            _hover: { backgroundColor: fillLevelToHoverBGColor[fillLevel] },
        }), theme.partials.scrollBar({ fillLevel }), props)) })));
});
export default Card;
//# sourceMappingURL=Card.js.map