var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Div, Flex } from 'honorable';
import { Children, forwardRef, useEffect, useState, } from 'react';
import { CSSTransition } from 'react-transition-group';
import { keyframes } from '@emotion/react';
import PropTypes from 'prop-types';
const propTypes = {
    autoAdvanceTime: PropTypes.number,
};
const dotAnimationIn = keyframes `
0% {
  transform: scale(1)
}
50% {
  transform: scale(1.15)
}
100% {
  transform: scale(1)
}
`;
function Dot(_a) {
    var { active = false, size = 8 } = _a, props = __rest(_a, ["active", "size"]);
    return (_jsx(Div, Object.assign({ padding: "xxsmall", cursor: "pointer" }, props, { children: _jsx(Div, { backgroundColor: active ? 'action-link-inline' : 'fill-two', transition: "background-color 0.35s cubic-bezier(.20,.55,.80,.45)", animationName: active ? dotAnimationIn : null, animationDuration: "0.75s", animationIterationCount: "1", width: size, height: size, borderRadius: "50%" }) })));
}
const transitionStyles = {
    opacity: 0,
    visibility: 'hidden',
    '&.appear, &.appear-active, &.appear-done': {
        opacity: 1,
        transform: 'translateY(0)',
        visibility: 'visible',
    },
    '&.enter': {
        visibility: 'visible',
        transform: 'scale(1.2)',
        filter: 'blur(10px)',
    },
    '&.enter-active': {
        transition: 'all 1.2s ease',
        transitionDelay: '0.3s',
        filter: 'blur(0)',
    },
    '&.enter-active,&.enter-done': {
        visibility: 'visible',
        transform: 'scale(1)',
        opacity: 1,
    },
    '&.exit': {
        transform: 'translateY(0)',
        opacity: 1,
        visibility: 'visible',
    },
    '&.exit-active': {
        transition: 'all 1.2s ease',
    },
    '&.exit-active, &.exit-done': {
        transform: ' scale(0.75)',
        opacity: 0,
        filter: 'blur(5px)',
    },
    '&.exit-done': {
        visibility: 'hidden',
    },
};
function CarouselRef(_a, ref) {
    var { autoAdvanceTime = 10000, children } = _a, props = __rest(_a, ["autoAdvanceTime", "children"]);
    const [activeIndex, setActiveIndex] = useState(0);
    useEffect(() => {
        if (autoAdvanceTime <= 0)
            return;
        const timer = setTimeout(() => {
            setActiveIndex(activeIndex >= Children.count(children) - 1 ? 0 : activeIndex + 1);
        }, autoAdvanceTime);
        return () => {
            clearTimeout(timer);
        };
    }, [activeIndex, autoAdvanceTime, children]);
    return (_jsxs(Div, Object.assign({ ref: ref, backgroundColor: "fill-one", border: "1px solid border", borderRadius: "medium" }, props, { children: [_jsx(Flex, Object.assign({ overflow: "hidden" }, { children: Children.map(children, (child, i) => (_jsx(Flex, Object.assign({ width: "100%", flexShrink: 0, justify: "center", alignItems: "stretch", transform: `translateX(${-i * 100}%)`, pointerEvents: activeIndex === i ? 'auto' : 'none' }, { children: _jsx(CSSTransition, Object.assign({ in: activeIndex === i, appear: true, timeout: 2000 }, { children: _jsx(Flex, Object.assign({ width: "100%", alignItems: "center" }, transitionStyles, { children: child })) })) })))) })), _jsx(Flex, Object.assign({ marginTop: "xsmall", marginBottom: "medium", justifyContent: "center" }, { children: Children.map(children, (_child, i) => (_jsx(Dot, { active: activeIndex === i, onClick: () => {
                        setActiveIndex(i);
                    } }))) }))] })));
}
const Carousel = forwardRef(CarouselRef);
Carousel.propTypes = propTypes;
export default Carousel;
//# sourceMappingURL=Carousel.js.map