var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, memo, useId, useRef, } from 'react';
import { Label } from 'honorable';
import classNames from 'classnames';
import styled from 'styled-components';
import PropTypes from 'prop-types';
import { useToggleState } from '@react-stately/toggle';
import { useCheckbox } from '@react-aria/checkbox';
import { VisuallyHidden } from '@react-aria/visually-hidden';
import { useFocusRing } from '@react-aria/focus';
const CheckedIcon = memo(({ small }) => {
    const width = small ? 16 : 24;
    return (_jsx("svg", Object.assign({ width: width, height: width, fill: "none", viewBox: `0 0 ${width} ${width}`, xmlns: "http://www.w3.org/2000/svg" }, { children: _jsx("path", { d: small ? 'm11 6-4 4-2-2' : 'm17 9-6 6-3-3', stroke: "currentColor", strokeLinecap: "round", strokeLinejoin: "round", strokeWidth: "2" }) })));
});
const IndeterminateIcon = memo(({ small }) => {
    const width = small ? 6 : 8;
    const height = small ? 2 : 3;
    return (_jsx("svg", Object.assign({ width: width, height: height, viewBox: `0 0 ${width} ${height}`, fill: "none", xmlns: "http://www.w3.org/2000/svg" }, { children: _jsx("rect", { x: "0", y: "0", width: width, height: height, rx: 0.5, fill: "currentColor" }) })));
});
const HonorableLabelStyled = styled(Label)(({ $small = false, $disabled = false, $isFocusVisible, theme, }) => (Object.assign(Object.assign(Object.assign({}, theme.partials.text.body2), { gap: theme.spacing.small, alignItems: 'center', padding: theme.spacing.xxsmall, color: $disabled
        ? theme.colors['text-input-disabled']
        : theme.colors['text-light'], cursor: $disabled ? 'not-allowed' : 'pointer', margin: 0, ':focus': {
        outline: 'none',
    }, '.box': Object.assign(Object.assign({ width: $small ? theme.spacing.medium : theme.spacing.large, height: $small ? theme.spacing.medium : theme.spacing.large, position: 'relative' }, ($isFocusVisible
        ? Object.assign(Object.assign({}, theme.partials.focus.outline), { border: 'none' }) : {})), { '::before, .icon': {
            position: 'absolute',
            content: '""',
            top: 0,
            left: 0,
            width: '100%',
            height: '100%',
        }, '::before, &': {
            borderRadius: theme.borderRadiuses.medium,
        }, 
        /* before for the border */
        '::before': Object.assign({ zIndex: 0, border: theme.borders.input }, ($disabled
            ? {
                borderColor: theme.colors['border-disabled'],
                backgroundColor: theme.colors['action-primary-disabled'],
            }
            : {})), '.icon': {
            zIndex: 2,
            display: 'flex',
            flexShrink: 0,
            flexGrow: 0,
            alignItems: 'center',
            justifyContent: 'center',
            color: !$disabled
                ? theme.colors['icon-default']
                : theme.colors['icon-disabled'],
        } }) }), (!$disabled
    ? {
        ':hover': {
            color: theme.colors.text,
            '> span': {
                backgroundColor: theme.colors['action-input-hover'],
            },
        },
        '&.checked': {
            color: theme.colors.text,
        },
        '&.checked, &.indeterminate': {
            '.box::before': {
                border: 'none',
                backgroundColor: theme.colors['action-primary'],
            },
        },
        ':hover.checked, :hover.indeterminate': {
            '.box::before': {
                border: 'none',
                backgroundColor: theme.colors['action-primary-hover'],
            },
        },
    }
    : {}))));
function Checkbox(_a, ref) {
    var { small, onChange, checked: checkedProp, indeterminate, disabled, defaultSelected, onFocus, onBlur, onFocusChange, onKeyDown, onKeyUp } = _a, props = __rest(_a, ["small", "onChange", "checked", "indeterminate", "disabled", "defaultSelected", "onFocus", "onBlur", "onFocusChange", "onKeyDown", "onKeyUp"]);
    const toggleStateProps = Object.assign(Object.assign({}, (checkedProp !== undefined ? { isSelected: checkedProp } : {})), { defaultSelected: !!defaultSelected });
    const labelId = useId();
    const toggleState = useToggleState(toggleStateProps);
    const inputRef = useRef();
    const { isFocusVisible, focusProps } = useFocusRing();
    const { inputProps } = useCheckbox(Object.assign(Object.assign({}, toggleStateProps), { isDisabled: disabled, onFocus,
        onBlur,
        onFocusChange,
        onKeyDown,
        onKeyUp, 'aria-labelledby': labelId, value: props.value, name: props.name }), toggleState, inputRef);
    const icon = indeterminate ? (_jsx(IndeterminateIcon, { small: small })) : toggleState.isSelected ? (_jsx(CheckedIcon, { small: small })) : null;
    return (_jsxs(HonorableLabelStyled, Object.assign({ htmlFor: inputProps.id, id: labelId, ref: ref, className: classNames({
            checked: toggleState.isSelected,
            indeterminate,
        }), "$isFocusVisible": isFocusVisible, "$small": small, "$disabled": disabled, display: "flex", marginBottom: "0" }, props, { children: [_jsx(VisuallyHidden, { children: _jsx("input", Object.assign({}, inputProps, focusProps, { onChange: e => {
                        if (typeof onChange === 'function') {
                            onChange(e);
                        }
                        inputProps.onChange(e);
                    }, ref: inputRef })) }), _jsx("div", Object.assign({ className: "box" }, { children: _jsx("div", Object.assign({ className: "icon" }, { children: icon })) })), _jsxs("div", Object.assign({ className: "label" }, { children: [" ", props.children] }))] })));
}
Checkbox.propTypes = {
    small: PropTypes.bool,
};
export default forwardRef(Checkbox);
//# sourceMappingURL=Checkbox.js.map