import { ComponentPropsWithRef, Dispatch, ReactElement } from 'react';
import { ChecklistFooterProps } from './ChecklistFooter';
import { ChecklistItemProps } from './ChecklistItem';
declare const Checklist: import("styled-components").StyledComponent<typeof ChecklistUnstyled, import("styled-components").DefaultTheme, {}, never>;
declare type ChecklistProps = ComponentPropsWithRef<'div'> & {
    label: string;
    stateProps: ChecklistStateProps;
    footerChildren: ReactElement<ChecklistFooterProps> | ReactElement<ChecklistFooterProps>[];
    completeChildren: ReactElement;
    children: ReactElement<ChecklistItemProps>[];
};
declare type ChecklistStateProps = {
    onSelectionChange?: Dispatch<number>;
    onFocusChange?: Dispatch<number>;
    onOpenChange?: Dispatch<boolean>;
    selectedKey?: number;
    focusedKey?: number;
    completedKey?: number;
    isOpen?: boolean;
    isDismissed?: boolean;
};
declare function ChecklistUnstyled({ label, stateProps, children, footerChildren, completeChildren, ...props }: ChecklistProps): JSX.Element;
export { Checklist, ChecklistStateProps, ChecklistProps };
