var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { createElement as _createElement } from "react";
import { useCallback, useEffect, useMemo, useRef, useState, } from 'react';
import AnimateHeight from 'react-animate-height';
import styled from 'styled-components';
import { ChecklistFooter } from './ChecklistFooter';
import { ChecklistItemInner } from './ChecklistItem';
import DropdownArrowIcon from './icons/DropdownArrowIcon';
const heightAnimationDuration = 333; // 333ms
const Checklist = styled(ChecklistUnstyled)(({ theme }) => ({
    background: theme.colors['fill-two'],
    color: theme.colors.text,
    display: 'flex',
    flexDirection: 'column',
    width: 480,
    '> div': {
        borderTop: theme.borders['outline-focused'],
        borderWidth: 4,
        borderTopRightRadius: theme.borderRadiuses.large,
    },
    '.header': Object.assign(Object.assign({}, theme.partials.text.subtitle1), { borderBottom: theme.borders['fill-two'], padding: `${theme.spacing.medium}px ${theme.spacing.large}px`, cursor: 'pointer', display: 'flex', flexDirection: 'row', justifyContent: 'space-between', alignItems: 'center' }),
    '.content': {
        padding: `${theme.spacing.xsmall}px 0`,
        borderBottom: theme.borders['fill-two'],
        display: 'flex',
        flexDirection: 'column',
    },
    '.finishContainer': {
        paddingTop: `${theme.spacing.large}px`,
        paddingBottom: `${theme.spacing.medium}px`,
    },
    '.shrink': {
        opacity: 0,
        visibility: 'hidden',
        transition: 'opacity 333ms linear, max-height 333ms linear',
    },
    '.grow': {
        transition: 'opacity 333ms linear, max-height 333ms linear',
    },
    '.arrowUp': Object.assign({}, theme.partials.dropdown.arrowTransition({ isOpen: true })),
    '.arrowDown': Object.assign({}, theme.partials.dropdown.arrowTransition({ isOpen: false })),
}));
function ChecklistUnstyled(_a) {
    var { label, stateProps, children, footerChildren, completeChildren } = _a, props = __rest(_a, ["label", "stateProps", "children", "footerChildren", "completeChildren"]);
    const { isOpen = true, isDismissed, selectedKey, focusedKey, completedKey, onSelectionChange, onFocusChange, onOpenChange, } = stateProps;
    const [finished, setFinished] = useState(false);
    const isFirstRender = useRef(true);
    const itemsContainerRef = useRef(null);
    const finishedContainerRef = useRef(null);
    const [itemContainerHeight, setItemContainerHeight] = useState(-1);
    const [finishedContainerHeight, setFinishedContainerHeight] = useState(-1);
    const onSelectionChangeWrapper = useCallback((idx) => (idx < children.length && idx > -1 ? onSelectionChange(idx) : undefined), [children, onSelectionChange]);
    const onFocusChangeWrapper = useCallback((idx) => (idx < children.length && idx > -1 ? onFocusChange(idx) : undefined), [children, onFocusChange]);
    const checklistItemInnerWrapper = useMemo(() => children.map((child, index) => (_createElement(ChecklistItemInner, Object.assign({}, child.props, { key: index, index: index, selected: selectedKey === index, focused: focusedKey === index, completed: completedKey >= index, onSelectionChange: onSelectionChangeWrapper, onFocusChange: onFocusChangeWrapper }), child))), [children, selectedKey, focusedKey, completedKey, onSelectionChangeWrapper, onFocusChangeWrapper]);
    useEffect(() => {
        setFinished(completedKey === children.length - 1);
    }, [completedKey, children.length, setFinished]);
    useEffect(() => {
        if (isFirstRender.current) {
            isFirstRender.current = false;
        }
    });
    useEffect(() => {
        const maxItemContainerHeight = Math.max(itemContainerHeight, itemsContainerRef.current.getBoundingClientRect().height);
        const maxFinishedContainerHeight = Math.max(finishedContainerHeight, finishedContainerRef.current.getBoundingClientRect().height);
        setItemContainerHeight(maxItemContainerHeight);
        setFinishedContainerHeight(maxFinishedContainerHeight);
    }, [itemsContainerRef, finishedContainerRef, setItemContainerHeight, setFinishedContainerHeight, itemContainerHeight, finishedContainerHeight]);
    return (_jsxs(AnimateHeight, Object.assign({ height: isDismissed ? 0 : 'auto' }, props, { children: [_jsxs("div", Object.assign({ className: finished ? 'shrink' : 'grow', style: finished ? { maxHeight: 0 } : { maxHeight: itemContainerHeight }, ref: itemsContainerRef }, { children: [_jsxs("div", Object.assign({ className: "header", onClick: () => onOpenChange(!isOpen) }, { children: [_jsx("div", { children: label }), _jsx(DropdownArrowIcon, { className: isOpen ? 'arrowUp' : 'arrowDown' })] })), _jsxs(AnimateHeight, Object.assign({ height: isFirstRender.current || isOpen ? 'auto' : 0, duration: heightAnimationDuration }, { children: [_jsx("div", Object.assign({ className: "content" }, { children: checklistItemInnerWrapper })), _jsx(ChecklistFooter, { children: footerChildren })] }))] })), _jsx("div", Object.assign({ className: finished ? 'finishContainer grow' : 'finishContainer shrink', style: isFirstRender.current || finished ? { maxHeight: finishedContainerHeight } : { maxHeight: 0, padding: 0 }, ref: finishedContainerRef }, { children: completeChildren }))] })));
}
export { Checklist };
//# sourceMappingURL=Checklist.js.map