var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useKeyboard } from '@react-aria/interactions';
import { useEffect, useRef, } from 'react';
import AnimateHeight from 'react-animate-height';
import styled from 'styled-components';
import CaretDownIcon from './icons/CaretDownIcon';
import SuccessIcon from './icons/SuccessIcon';
const heightAnimationDuration = 333; // 333ms
const ChecklistItemInner = styled(ChecklistItemInnerUnstyled)(({ theme, completed, selected }) => ({
    display: 'flex',
    flexDirection: 'column',
    '.itemHeader': {
        padding: `${theme.spacing.xsmall}px ${theme.spacing.large}px`,
        display: 'flex',
        gap: 12,
        alignItems: 'center',
        color: selected ? theme.colors['action-link-active'] : theme.colors['action-link-inactive'],
        cursor: 'pointer',
        ':hover': {
            background: theme.colors['fill-two-hover'],
        },
        ':focus': {
            outline: `${theme.colors['border-outline-focused']} solid 1px`,
        },
        '.itemCircle': Object.assign(Object.assign(Object.assign({ position: 'relative', display: 'flex', alignItems: 'center', justifyContent: 'center', width: 32, height: 32, borderRadius: '100%', background: theme.colors['fill-three'] }, theme.partials.text.body2), (!selected && {
            border: theme.borders['fill-three'],
        })), { '> span': {
                position: 'absolute',
                opacity: completed ? 1 : 0,
                animation: completed ? 'overshoot 0.33s' : 'none',
            }, '> div': {
                opacity: completed ? 0 : 1,
            }, '&::after, &::before': {
                content: '""',
                position: 'absolute',
                width: '100%',
                height: '100%',
                top: 0,
                left: 0,
                borderRadius: '100%',
            }, '&:before': Object.assign({ border: '1px solid transparent' }, (selected && {
                borderTopColor: theme.colors['action-link-active'],
                borderRightColor: theme.colors['action-link-active'],
                borderBottomColor: theme.colors['action-link-active'],
                transition: `
            border-top-color 0.1s linear,
            border-right-color 0.1s linear 0.1s,
            border-bottom-color 0.1s linear 0.2s`,
            })), '&:after': Object.assign({ border: '0 solid transparent' }, (selected && {
                borderTop: `1px solid ${theme.colors['action-link-active']}`,
                borderLeftWidth: '1px',
                borderRightWidth: '1px',
                transform: 'rotate(270deg)',
                transition: `
            transform 0.3s linear 0s,
            border-left-width 0.1s linear 0.3s`,
            })) }),
        '.itemTitle': {
            flex: '1 1 auto',
        },
    },
    '.itemContainer': {
        padding: `0 ${theme.spacing.large}px`,
        display: 'flex',
        gap: 28,
        color: theme.colors['text-light'],
        '.itemLine': {
            width: 1,
            background: theme.colors['action-link-active'],
            marginLeft: 16,
        },
        '.itemContent': {
            padding: `${theme.spacing.xsmall}px 0`,
        },
    },
    '@keyframes overshoot': {
        '0%': {
            transform: 'scale(0)',
        },
        '20%': {
            transform: 'scale(0.3)',
        },
        '40%': {
            transform: 'scale(0.6)',
        },
        '60%': {
            transform: 'scale(0.9)',
        },
        '80%': {
            transform: 'scale(1.2)',
        },
        '100%': {
            transform: 'scale(1)',
        },
    },
}));
function ChecklistItem(_a) {
    var { children } = _a, props = __rest(_a, ["children"]);
    return (_jsx("div", Object.assign({}, props, { children: children })));
}
var KeyboardKey;
(function (KeyboardKey) {
    KeyboardKey["ARROW_DOWN"] = "ArrowDown";
    KeyboardKey["ARROW_UP"] = "ArrowUp";
    KeyboardKey["ENTER"] = "Enter";
    KeyboardKey["SPACE"] = " ";
})(KeyboardKey || (KeyboardKey = {}));
function ChecklistItemInnerUnstyled(_a) {
    var { children, index, title, selected, focused, onSelectionChange, onFocusChange } = _a, props = __rest(_a, ["children", "index", "title", "selected", "focused", "onSelectionChange", "onFocusChange"]);
    const headerRef = useRef();
    const { keyboardProps } = useKeyboard({
        onKeyDown: e => {
            switch (e.key) {
                case KeyboardKey.ARROW_UP:
                    if (focused) {
                        onSelectionChange(index - 1);
                        onFocusChange(index - 1);
                    }
                    break;
                case KeyboardKey.ARROW_DOWN:
                    if (focused) {
                        onSelectionChange(index + 1);
                        onFocusChange(index + 1);
                    }
                    break;
                case KeyboardKey.ENTER:
                case KeyboardKey.SPACE:
                    onSelectionChange(selected ? null : index);
            }
        },
    });
    useEffect(() => {
        if (headerRef.current && focused) {
            setTimeout(() => headerRef.current.focus());
        }
    }, [headerRef, focused]);
    return (_jsxs("div", Object.assign({}, props, { children: [_jsxs("div", Object.assign({}, keyboardProps, { className: "itemHeader", role: "button", tabIndex: 0, ref: headerRef, onClick: () => onSelectionChange(selected ? null : index), onFocus: () => onFocusChange(index), onBlur: () => onFocusChange(-1) }, { children: [_jsxs("div", Object.assign({ className: "itemCircle" }, { children: [_jsx("div", { children: index + 1 }), _jsx(SuccessIcon, { size: 16, color: "icon-success" })] })), _jsx("div", Object.assign({ className: "itemTitle" }, { children: title })), _jsx(CaretDownIcon, { className: selected ? 'arrowUp' : 'arrowDown' })] })), _jsx(AnimateHeight, Object.assign({ height: selected ? 'auto' : 0, duration: heightAnimationDuration }, { children: _jsxs("div", Object.assign({ className: "itemContainer" }, { children: [_jsx("div", { className: "itemLine" }), _jsx("div", Object.assign({ className: "itemContent" }, { children: children }))] })) }))] })));
}
export { ChecklistItem, ChecklistItemInner };
//# sourceMappingURL=ChecklistItem.js.map