var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Flex, Spinner } from 'honorable';
import PropTypes from 'prop-types';
import { forwardRef } from 'react';
import styled from 'styled-components';
import Card from './Card';
import { useFillLevel } from './contexts/FillLevelContext';
import CloseIcon from './icons/CloseIcon';
const parentFillLevelToHue = {
    0: 'default',
    1: 'lighter',
    2: 'lightest',
    3: 'lightest',
};
const severityToColor = {
    neutral: 'text',
    info: 'text-primary-accent',
    success: 'text-success-light',
    warning: 'text-warning-light',
    error: 'text-danger-light',
    critical: 'text-danger',
};
const sizeToCloseHeight = {
    small: 8,
    medium: 10,
    large: 12,
};
const ChipCard = styled(Card)(({ theme }) => ({
    '.closeIcon': {
        color: theme.colors['text-light'],
    },
    '&:hover': {
        '.closeIcon': {
            color: theme.colors.text,
        },
    },
}));
function ChipRef(_a, ref) {
    var { children, size = 'medium', severity = 'neutral', hue, loading = false, icon, closeButton, clickable } = _a, props = __rest(_a, ["children", "size", "severity", "hue", "loading", "icon", "closeButton", "clickable"]);
    const parentFillLevel = useFillLevel();
    hue = hue || parentFillLevelToHue[parentFillLevel];
    const col = severityToColor[severity] || 'text-light';
    return (_jsxs(ChipCard, Object.assign({ ref: ref, cornerSize: "medium", hue: hue, clickable: clickable, paddingVertical: size === 'large' ? '6px' : 'xxxsmall', paddingHorizontal: size === 'small' ? 'xsmall' : 'small', alignItems: "center", display: "inline-flex" }, props, { children: [loading && (_jsx(Spinner, { color: col, size: size === 'large' ? 15 : 13, marginRight: "xsmall" })), icon && (_jsx(icon.type, { size: size === 'large' ? 15 : 13, marginRight: "xsmall", color: col })), _jsx(Flex, Object.assign({ body2: true, color: col, fontSize: size === 'small' ? 12 : 14, fontWeight: size === 'small' ? 400 : 600, lineHeight: size === 'small' ? '16px' : '20px', gap: 4 }, { children: children })), closeButton && (_jsx(CloseIcon, { className: "closeIcon", paddingLeft: "xsmall", size: sizeToCloseHeight[size], _hover: { color: 'blue' } }))] })));
}
const Chip = forwardRef(ChipRef);
Chip.propTypes = {
    size: PropTypes.oneOf(['small', 'medium', 'large']),
    severity: PropTypes.oneOf([
        'neutral',
        'info',
        'success',
        'warning',
        'error',
        'critical',
    ]),
    hue: PropTypes.oneOf(['default', 'lighter', 'lightest']),
    icon: PropTypes.element,
    loading: PropTypes.bool,
};
export default Chip;
//# sourceMappingURL=Chip.js.map