var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, useEffect, useState, } from 'react';
import { Div, Flex, } from 'honorable';
import { useTheme } from 'styled-components';
import Tooltip from '../components/Tooltip';
import CopyIcon from './icons/CopyIcon';
const propTypes = {};
function CodelineRef(_a, ref) {
    var { children, displayText } = _a, props = __rest(_a, ["children", "displayText"]);
    const [copied, setCopied] = useState(false);
    const theme = useTheme();
    useEffect(() => {
        if (copied) {
            const timeout = setTimeout(() => setCopied(false), 1000);
            return () => clearTimeout(timeout);
        }
    }, [copied]);
    const handleCopy = () => window.navigator.clipboard.writeText(children).then(() => setCopied(true));
    return (_jsxs(Flex, Object.assign({ ref: ref, border: "1px solid border-input", borderRadius: "medium" }, props, { children: [_jsx(Flex, Object.assign({ align: "center", paddingVertical: "xsmall", paddingHorizontal: "medium", overflowX: "auto", flexGrow: 1, position: "relative" }, { children: _jsx(Div, Object.assign({ body2: true }, theme.partials.text.code, { color: "text-light", flexGrow: 1, whiteSpace: "pre", textOverflow: "ellipsis", overflow: "hidden" }, { children: displayText || children })) })), _jsx(Flex, Object.assign({ width: 38, height: 38, alignItems: "center", justifyContent: "center", flexShrink: 0 }, { children: _jsx(Tooltip, Object.assign({ offset: 8, label: "Copied!", color: "text-success-light", placement: "top", displayOn: "manual", dismissable: true, onOpenChange: open => {
                        if (!open && copied)
                            setCopied(false);
                    }, manualOpen: copied }, { children: _jsx(Flex, Object.assign({ alignItems: "center", justifyContent: "center", width: 32, height: 32, cursor: "pointer", borderRadius: "medium", _hover: { backgroundColor: 'fill-zero-hover' }, _active: { backgroundColor: 'fill-zero-selected' }, onClick: handleCopy }, { children: _jsx(CopyIcon, Object.assign({ color: "text-light" }, { '& svg': { display: 'block' } })) })) })) }))] })));
}
const Codeline = forwardRef(CodelineRef);
Codeline.propTypes = propTypes;
export default Codeline;
//# sourceMappingURL=Codeline.js.map