import { MouseEventHandler, ReactElement, ReactNode } from 'react';
import { ComboBoxStateOptions } from '@react-stately/combobox';
import { ListBoxItemBaseProps } from './ListBoxItem';
import { InputProps } from './Input';
declare type Placement = 'left' | 'right';
declare type ComboBoxProps = Exclude<ComboBoxInputProps, 'children'> & {
    children: ReactElement<ListBoxItemBaseProps> | ReactElement<ListBoxItemBaseProps>[];
    dropdownHeaderFixed?: ReactNode;
    dropdownFooterFixed?: ReactNode;
    dropdownHeader?: ReactElement;
    dropdownFooter?: ReactElement;
    onHeaderClick?: () => unknown;
    onFooterClick?: () => unknown;
    startIcon?: ReactNode;
    placement?: Placement;
    width?: string | number;
    maxHeight?: string | number;
    inputProps?: InputProps;
    filter?: ComboBoxStateOptions<object>['defaultFilter'];
} & Omit<ComboBoxStateOptions<object>, 'onLoadMore' | 'isLoading' | 'validationState' | 'placeholder'>;
export declare const ComboBoxInputInner: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    isOpen: boolean;
}, never>;
declare type ComboBoxInputProps = {
    showArrow?: boolean;
    isOpen?: boolean;
    outerInputProps?: InputProps;
    onInputClick?: MouseEventHandler;
};
declare function ComboBox({ children, selectedKey, inputValue, onSelectionChange, onFocusChange, onOpenChange, onInputChange, isOpen, dropdownHeader, dropdownFooter, dropdownHeaderFixed, dropdownFooterFixed, onHeaderClick, onFooterClick, showArrow, startIcon, placement, width, maxHeight, inputProps: outerInputProps, ...props }: ComboBoxProps): JSX.Element;
export { ComboBox, ComboBoxProps };
