var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, useEffect, useMemo, useRef, } from 'react';
import hljs from 'highlight.js/lib/core';
import '../hljs';
import styled from 'styled-components';
const MainWrap = styled.div(({ theme }) => ({
    display: 'flex',
    gap: theme.spacing.large,
}));
const StyledPre = styled.pre(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.code), { background: 'none', margin: 0, padding: 0 })));
const LineNumbers = styled(StyledPre)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.code), { pointerEvents: 'none', userSelect: 'none', display: 'flex', textAlign: 'right' })));
const StyledHighlight = styled.div(_ => `
pre code.hljs {
  display: block;
  overflow-x: auto;
  padding: 1em;
}

code.hljs {
  padding: 3px 5px;
}

.hljs ::selection,
.hljs::selection {
  background-color: #383a62;
  color: #ebeff0;
}

.hljs-comment {
  color: #747b8b;
}

.hljs-tag {
  color: #c5c9d3;
}

.hljs-operator,
.hljs-punctuation,
.hljs-subst {
  color: #ebeff0;
}

.hljs-operator {
  opacity: 0.7;
}

.hljs-bullet,
.hljs-deletion,
.hljs-name,
.hljs-selector-tag,
.hljs-template-variable,
.hljs-variable {
  color: #c5c9d3;
}

.hljs-attr,
.hljs-link,
.hljs-literal,
.hljs-number,
.hljs-symbol,
.hljs-variable.constant_ {
  color: #969af8;
}

.hljs-class .hljs-title,
.hljs-title,
.hljs-title.class_ {
  color: #7075f5;
}

.hljs-strong {
  font-weight: 700;
  color: #7075f5;
}
.hljs-addition,
.hljs-code,
.hljs-string,
.hljs-title.class_.inherited__ {
  color: #8fd6ff;
}
.hljs-built_in,
.hljs-doctag,
.hljs-keyword.hljs-atrule,
.hljs-quote,
.hljs-regexp {
  color: #c2e9ff;
}

.hljs-attribute,
.hljs-function .hljs-title,
.hljs-section,
.hljs-title.function_,
.ruby .hljs-property {
  color: #3cecaf;
}

.diff .hljs-meta,
.hljs-keyword,
.hljs-template-tag,
.hljs-type {
  color: #fff48f;
}

.hljs-emphasis {
  color: #fff48f;
  font-style: italic;
}

.hljs-meta,
.hljs-meta .hljs-keyword,
.hljs-meta .hljs-string {
  color: #99f5d5;
}

.hljs-meta .hljs-keyword,
.hljs-meta-keyword {
  font-weight: 700;
}`);
const propTypes = {};
function HighlightRef(_a, ref) {
    var { language, children, showLineNumbers } = _a, props = __rest(_a, ["language", "children", "showLineNumbers"]);
    if (typeof children !== 'string') {
        throw new Error('Highlight component expects a string as its children');
    }
    const codeRef = useRef();
    const lines = useMemo(() => children.split(/\r?\n/), [children]);
    useEffect(() => {
        if (hljs.getLanguage(language) && codeRef.current) {
            hljs.initHighlighting();
            hljs.highlightBlock(codeRef.current);
        }
    }, [language, children]);
    return (_jsxs(MainWrap, Object.assign({ ref: ref }, { children: [showLineNumbers && (_jsx(LineNumbers, Object.assign({ "aria-hidden": true }, { children: lines.map((line, idx) => `${idx + 1}${idx < lines.length - 1 ? '\n' : ''}`) }))), _jsx(StyledHighlight, { children: _jsx(StyledPre, Object.assign({ className: language ? `language-${language}` : 'nohighlight', ref: codeRef }, props, { children: children })) })] })));
}
const Highlight = forwardRef(HighlightRef);
Highlight.propTypes = propTypes;
export default Highlight;
//# sourceMappingURL=Highlight.js.map