import { ReactElement, ReactNode } from 'react';
import { FlexProps } from 'honorable';
import { TooltipProps } from './Tooltip';
declare type Hue = 'none' | 'default' | 'lighter' | 'lightest';
declare type Size = 'xsmall' | 'small' | 'medium' | 'large' | 'xlarge';
declare type IconFrameProps = Omit<FlexProps, 'size'> & {
    hue?: Hue;
    clickable?: boolean;
    textValue: string;
    icon: ReactElement;
    size?: Size;
    tooltip?: boolean | ReactNode;
    tooltipProps?: Partial<TooltipProps>;
};
declare const IconFrame: import("react").ComponentType<Omit<FlexProps, "size"> & {
    hue?: Hue;
    clickable?: boolean;
    textValue: string;
    icon: ReactElement;
    size?: Size;
    tooltip?: boolean | ReactNode;
    tooltipProps?: Partial<TooltipProps>;
} & import("react").RefAttributes<HTMLDivElement>>;
export default IconFrame;
export { IconFrameProps };
