var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { cloneElement, forwardRef, } from 'react';
import { ButtonBase, Flex } from 'honorable';
import { useTheme } from 'styled-components';
import Tooltip from './Tooltip';
import { useFillLevel } from './contexts/FillLevelContext';
const parentFillLevelToHue = {
    0: 'none',
    1: 'default',
    2: 'lighter',
    3: 'lightest',
};
const hueToHoverBG = {
    none: 'fill-zero-hover',
    default: 'fill-one-hover',
    lighter: 'fill-two-hover',
    lightest: 'fill-three-hover',
};
const sizeToIconSize = {
    xsmall: 8,
    small: 16,
    medium: 16,
    large: 24,
    xlarge: 24,
};
const sizeToFrameSize = {
    xsmall: 16,
    small: 24,
    medium: 32,
    large: 40,
    xlarge: 48,
};
const IconFrame = forwardRef((_a, ref) => {
    var { icon, size = 'medium', hue, textValue, clickable = false, tooltip, tooltipProps } = _a, props = __rest(_a, ["icon", "size", "hue", "textValue", "clickable", "tooltip", "tooltipProps"]);
    const theme = useTheme();
    const parentFillLevel = useFillLevel();
    if (!hue) {
        hue = parentFillLevelToHue[parentFillLevel];
    }
    icon = cloneElement(icon, { size: sizeToIconSize[size] });
    if (tooltip && typeof tooltip === 'boolean') {
        tooltip = textValue;
    }
    let content = (_jsx(Flex, Object.assign({ ref: ref, flex: false, alignItems: "center", justifyContent: "center", width: sizeToFrameSize[size], height: sizeToFrameSize[size], borderRadius: theme.borderRadiuses.medium, "aria-label": textValue }, { '&:focus,&:focus-visible': { outline: 'none' } }, { _focusVisible: Object.assign({}, theme.partials.focus.default) }, {
        '&,&:any-link': {
            textDecoration: 'none',
            border: 'unset',
            background: 'unset',
            color: 'unset',
            appearance: 'unset',
        },
    }, (clickable && {
        as: ButtonBase,
        tabIndex: 0,
        role: 'button',
        cursor: 'pointer',
        '&:hover': {
            backgroundColor: clickable
                && (theme.colors[hueToHoverBG[hue]]
                    || theme.colors[hueToHoverBG.default]),
        },
    }), props, { children: icon })));
    if (tooltip) {
        content = (_jsx(Tooltip, Object.assign({ displayOn: "hover", arrow: true, placement: "top", label: tooltip }, tooltipProps, { children: content })));
    }
    return content;
});
export default IconFrame;
//# sourceMappingURL=IconFrame.js.map