var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef } from 'react';
import styled from 'styled-components';
import { useFillLevel } from './contexts/FillLevelContext';
// This nonsense is to reduce the chance of there being
// a left margin when a <code> block is the first item in a line of text.
// Put em space character in pseudo element so it won't ever get copied
//
// Investigate replacing Spacer with 'margin-trim' css property when browser
// support exists
//
const Spacer = styled.span(_ => ({
    fontSize: 1.5,
    display: 'inline',
    lineHeight: 0,
    '&:after': {
        fontSize: 1.5,
        lineHeight: 0,
        content: '"\u2001"',
        display: 'inline',
        opacity: 0, // hides link underlines that can extend outside rectangle
    },
}));
const parentFillLevelToBorderColor = {
    0: 'border',
    1: 'border-fill-two',
    2: 'border-fill-three',
    3: 'border-fill-three',
};
// Magic number to make the total height equal 20px when within 14px type
// Proportional to that for larger text sizes
// If INLINE_CODE_MIN_PX changes in theme/text.ts, this needs to change too
// I cannot for the life of me find a way to just calculate this in a way that's
// consistent when INLINE_CODE_MIN_PX changes.
const PADDING_EMS = 0.1669;
const Code = styled.code(({ theme, parentFillLevel }) => (Object.assign(Object.assign({}, theme.partials.text.inlineCode), { border: theme.borders.default, borderRadius: theme.borderRadiuses.large, paddingRight: theme.spacing.xxsmall, paddingLeft: theme.spacing.xxsmall, paddingTop: `${PADDING_EMS}em`, paddingBottom: `${PADDING_EMS}em`, color: theme.colors['text-light'], borderColor: theme.colors[parentFillLevelToBorderColor[parentFillLevel]], backgroundColor: theme.colors['fill-one'], 'a:any-link &': {
        color: theme.colors['action-link-inline'],
    }, 'a:hover &': {
        color: theme.colors['action-link-inline-hover'],
    }, 'a:visited &, a:active &': {
        color: theme.colors['action-link-inline-visited'],
    } })));
const InlineCode = forwardRef((_a, ref) => {
    var props = __rest(_a, []);
    const parentFillLevel = useFillLevel();
    return (_jsxs(_Fragment, { children: [_jsx(Spacer, {}), _jsx(Code, Object.assign({ ref: ref, parentFillLevel: parentFillLevel }, props)), _jsx(Spacer, {})] }));
});
export default InlineCode;
//# sourceMappingURL=InlineCode.js.map