import { ComponentPropsWithRef, Key, ReactElement, ReactNode, RefObject } from 'react';
import { AriaListBoxOptions } from '@react-aria/listbox';
import { ListState } from '@react-stately/list';
import { CSSObject } from 'styled-components';
export declare const HEADER_KEY = "$$header$$";
export declare const FOOTER_KEY = "$$footer$$";
declare type ListBoxUnmanagedProps = AriaListBoxOptions<object> & ComponentPropsWithRef<'div'> & {
    state: ListState<object>;
    headerFixed?: ReactNode;
    footerFixed?: ReactNode;
    extendStyle?: CSSObject;
    listBoxRef?: RefObject<any>;
};
declare type ListBoxProps = Omit<ListBoxUnmanagedProps, 'state' | 'nextFocusedKeyRef' | 'onSelectionChange'> & {
    selectedKey: Key;
    onSelectionChange: (key: Key) => unknown;
    onHeaderClick?: () => unknown;
    onFooterClick?: () => unknown;
    disallowEmptySelection?: boolean;
    children: ReactElement | ReactElement[];
    header?: ReactElement;
    footer?: ReactElement;
};
declare function useItemWrappedChildren(children: ReactElement | ReactElement[], header?: ReactElement, footer?: ReactElement): JSX.Element[];
declare function ListBox({ disallowEmptySelection, selectedKey, children, header, footer, onSelectionChange, onHeaderClick, onFooterClick, ...props }: ListBoxProps): JSX.Element;
declare function ListBoxUnmanaged({ state, headerFixed, footerFixed, extendStyle, className, listBoxRef, ...props }: ListBoxUnmanagedProps): JSX.Element;
export { ListBox, ListBoxProps, ListBoxUnmanaged, ListBoxUnmanagedProps, useItemWrappedChildren, };
