import { ComponentPropsWithRef, ComponentPropsWithoutRef, ElementType, ReactNode } from 'react';
import { ItemProps } from '@react-types/shared';
import ChipList from './ListBoxItemChipList';
declare type ListBoxItemBaseProps = {
    focused?: boolean;
    selected?: boolean;
    disabled?: boolean;
    label?: ReactNode;
    description?: ReactNode;
    key?: string;
    labelProps?: ComponentPropsWithoutRef<ElementType>;
    descriptionProps?: ComponentPropsWithoutRef<ElementType>;
} & ComponentPropsWithRef<'div'> & Omit<ItemProps<void>, 'children'>;
declare const ListBoxItem: import("react").ComponentType<{
    leftContent?: ReactNode;
    rightContent?: ReactNode;
    reserveSelectedIndicatorSpace?: boolean;
    destructive?: boolean;
} & {
    focused?: boolean;
    selected?: boolean;
    disabled?: boolean;
    label?: ReactNode;
    description?: ReactNode;
    key?: string;
    labelProps?: ComponentPropsWithoutRef<ElementType>;
    descriptionProps?: ComponentPropsWithoutRef<ElementType>;
} & Pick<import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "key" | keyof import("react").HTMLAttributes<HTMLDivElement>> & {
    ref?: import("react").Ref<HTMLDivElement>;
} & Omit<ItemProps<void>, "children"> & import("react").RefAttributes<HTMLDivElement>>;
declare type ListBoxFooterProps = ComponentPropsWithRef<'div'> & {
    children: ReactNode;
    leftContent?: ReactNode;
    rightContent?: ReactNode;
};
declare const ListBoxFooter: import("react").ComponentType<Pick<import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "key" | keyof import("react").HTMLAttributes<HTMLDivElement>> & {
    ref?: import("react").Ref<HTMLDivElement>;
} & {
    children: ReactNode;
    leftContent?: ReactNode;
    rightContent?: ReactNode;
} & import("react").RefAttributes<HTMLDivElement>>;
declare const ListBoxFooterPlus: import("react").ComponentType<Pick<import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "key" | keyof import("react").HTMLAttributes<HTMLDivElement>> & {
    ref?: import("react").Ref<HTMLDivElement>;
} & {
    children: ReactNode;
    leftContent?: ReactNode;
    rightContent?: ReactNode;
} & import("react").RefAttributes<HTMLDivElement>>;
export { ListBoxItem, ListBoxItemBaseProps, ChipList as ListBoxItemChipList, ListBoxFooter, ListBoxFooterProps, ListBoxFooterPlus, ListBoxFooterProps as ListBoxFooterPlusProps, };
