var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, } from 'react';
import styled from 'styled-components';
import theme from 'honorable-theme-default';
import StatusOkIcon from './icons/StatusOkIcon';
import PlusIcon from './icons/PlusIcon';
import ChipList from './ListBoxItemChipList';
const ListBoxItemInner = styled.div(({ theme, disabled, selected, focused, destructive, }) => (Object.assign(Object.assign({ display: 'flex', flexDirection: 'row', alignItems: 'center', position: 'relative', width: 'auto', borderBottom: theme.borders['fill-two'], padding: `${theme.spacing.xsmall}px ${theme.spacing.medium}px`, backgroundColor: 'none', cursor: 'pointer', '&:hover': {
        backgroundColor: !disabled ? theme.colors['fill-two-hover'] : 'none',
    }, '&:focus, &:focus-visible': {
        outline: 'none',
    }, '&:last-child': {
        borderBottom: 'none',
    }, '&:focus-visible::after': Object.assign({}, theme.partials.focus.insetAbsolute) }, (focused
    ? {
        '&::after': Object.assign({}, theme.partials.focus.insetAbsolute),
    }
    : {})), { '.left-content': {
        marginRight: theme.spacing.small,
    }, '.right-content, .selected-indicator': {
        marginLeft: theme.spacing.xsmall,
        color: theme.colors['action-primary'],
    }, '.center-content': {
        flexGrow: 1,
        width: 'max-content',
    }, '.label': Object.assign(Object.assign({}, theme.partials.text.body2), { color: disabled
            ? theme.colors['text-primary-disabled']
            : destructive
                ? theme.colors['text-danger']
                : theme.colors.text }), '.description': Object.assign(Object.assign({}, theme.partials.text.caption), { color: theme.colors['text-xlight'] }), '.selected-indicator': {
        opacity: selected ? 1 : 0,
        position: 'relative',
        '& svg': {
            zIndex: 0,
        },
        '&::before': {
            content: '""',
            position: 'absolute',
            top: '2px',
            right: '2px',
            left: '2px',
            bottom: '2px',
            backgroundColor: theme.colors.text,
            borderRadius: '50%',
        },
    } })));
const ListBoxItem = forwardRef((_a, ref) => {
    var { selected, label, labelProps = {}, description, descriptionProps = {}, leftContent, rightContent, reserveSelectedIndicatorSpace } = _a, props = __rest(_a, ["selected", "label", "labelProps", "description", "descriptionProps", "leftContent", "rightContent", "reserveSelectedIndicatorSpace"]);
    return (_jsxs(ListBoxItemInner, Object.assign({ ref: ref, selected: selected }, props, { children: [leftContent && _jsx("div", Object.assign({ className: "left-content" }, { children: leftContent })), _jsxs("div", Object.assign({ className: "center-content" }, { children: [label && (_jsx("div", Object.assign({ className: "label" }, labelProps, { children: label }))), description && (_jsx("div", Object.assign({ className: "description" }, descriptionProps, { children: description })))] })), rightContent && _jsx("div", Object.assign({ className: "right-content" }, { children: rightContent })), (selected || reserveSelectedIndicatorSpace) && (_jsx(StatusOkIcon, { className: "selected-indicator", size: 16 }))] })));
});
const ListBoxFooterInner = styled.div(({ theme, focused = false }) => (Object.assign(Object.assign(Object.assign({}, theme.partials.reset.button), { display: 'flex', position: 'relative', width: '100%', padding: `${theme.spacing.small}px ${theme.spacing.medium}px`, '&:hover': {
        backgroundColor: theme.colors['fill-two-hover'],
    }, '.children': {
        flexGrow: 1,
    }, '.leftContent': {
        marginRight: theme.spacing.small,
    }, '.rightContent': {
        marginLeft: theme.spacing.small,
    }, '&:focus, &:focus-visible': {
        outline: 'none',
    }, '&:focus-visible::after': Object.assign({}, theme.partials.focus.insetAbsolute) }), (focused
    ? {
        '&::after': Object.assign({}, theme.partials.focus.insetAbsolute),
    }
    : {}))));
const ListBoxFooter = forwardRef((_a, ref) => {
    var { leftContent, rightContent, children } = _a, props = __rest(_a, ["leftContent", "rightContent", "children"]);
    return (_jsxs(ListBoxFooterInner, Object.assign({ tabIndex: 0, ref: ref }, props, { children: [leftContent && _jsx("div", Object.assign({ className: "leftContent" }, { children: leftContent })), _jsx("div", Object.assign({ className: "children" }, { children: children })), rightContent && _jsx("div", Object.assign({ className: "rightContent" }, { children: rightContent }))] })));
});
const ListBoxFooterPlusInner = styled(ListBoxFooter)(({ theme }) => ({
    color: theme.colors['text-primary-accent'],
}));
const ListBoxFooterPlus = forwardRef((_a, ref) => {
    var { leftContent, children } = _a, props = __rest(_a, ["leftContent", "children"]);
    return (_jsx(ListBoxFooterPlusInner, Object.assign({ ref: ref, leftContent: leftContent || (_jsx(PlusIcon, Object.assign({ size: 16, color: theme.colors['text-primary-accent'] }, { children: children || 'Add' }))) }, props, { children: children })));
});
export { ListBoxItem, ChipList as ListBoxItemChipList, ListBoxFooter, ListBoxFooterPlus, };
//# sourceMappingURL=ListBoxItem.js.map