var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { cloneElement, forwardRef, useMemo, } from 'react';
import styled from 'styled-components';
import Tooltip from './Tooltip';
import Chip from './Chip';
const ChipListUnstyled = forwardRef((_a, ref) => {
    var { chips, maxVisible = 3, showExtra = true } = _a, props = __rest(_a, ["chips", "maxVisible", "showExtra"]);
    const chipHue = 'lightest';
    if (!Array.isArray(chips)) {
        chips = [];
    }
    chips = chips.filter(chip => !!chip);
    const firstChips = useMemo(() => chips
        .slice(0, maxVisible)
        .map((chip, i) => cloneElement(chip, { hue: chipHue, key: i })), [chips, maxVisible]);
    const restChips = useMemo(() => chips.slice(maxVisible), [chips, maxVisible]);
    const extra = useMemo(() => (showExtra && restChips.length > 0 ? (_jsx(Tooltip, Object.assign({ placement: "top", label: (_jsx(_Fragment, { children: restChips.map((n, i) => {
                var _a;
                return (_jsxs("div", Object.assign({ className: "tooltip" }, { children: [(_a = n === null || n === void 0 ? void 0 : n.props) === null || _a === void 0 ? void 0 : _a.children, _jsx("br", {})] }), i));
            }) })) }, { children: _jsx(Chip, Object.assign({ size: "small", hue: chipHue }, { children: `+${restChips.length}` })) }), "extra")) : null), [restChips, showExtra]);
    return (_jsx("div", Object.assign({ ref: ref }, props, { children: [...firstChips, extra] })));
});
const ChipList = styled(ChipListUnstyled)(({ theme }) => ({
    display: 'flex',
    flexDiretion: 'row',
    flexWrap: 'wrap',
    justifyContent: 'end',
    gap: theme.spacing.xxsmall,
    '.tooltip': Object.assign({}, theme.partials.text.caption),
}));
export default ChipList;
//# sourceMappingURL=ListBoxItemChipList.js.map