var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { Children, useMemo } from 'react';
import { Div } from 'honorable';
import ReactMarkdown from 'react-markdown';
import rehypeRaw from 'rehype-raw';
import styled from 'styled-components';
import MultilineCode from './Code';
import InlineCode from './InlineCode';
const render = ({ component: Component, props: extraProps }) => function renderComponent(_a) {
    var { node: _ } = _a, props = __rest(_a, ["node"]);
    return (_jsx(Component, Object.assign({}, Object.assign(Object.assign({}, props), extraProps))));
};
function getLastStringChild(children, depth = 0) {
    let lastChild = null;
    Children.forEach(children, child => {
        if (typeof child === 'string') {
            lastChild = child;
        }
        else if (child.props && child.props.children && depth < 3) {
            lastChild = getLastStringChild(child.props.children, depth + 1);
        }
    });
    return lastChild;
}
function MarkdownPreformatted(_a) {
    var _b, _c;
    var { children } = _a, props = __rest(_a, ["children"]);
    let lang;
    if ((_c = (_b = children.props) === null || _b === void 0 ? void 0 : _b.className) === null || _c === void 0 ? void 0 : _c.startsWith('lang-')) {
        lang = children.props.className.slice(5);
    }
    const stringChild = getLastStringChild(children) || '';
    return (_jsx(Div, Object.assign({ mb: 1 }, { children: _jsx(MultilineCode, Object.assign({ language: lang }, props, { children: stringChild })) })));
}
const commonCfg = { shouldForwardProp: () => true };
const MdBlockquote = styled.blockquote.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({ position: 'relative' }, theme.partials.text.body1), { color: theme.colors['text-light'], margin: 0, marginLeft: theme.spacing.xlarge - 1, borderLeft: `2px solid ${theme.colors.border}`, padding: '0', paddingLeft: theme.spacing.xlarge - 1, boxShadow: 'none', '& p': Object.assign(Object.assign({}, theme.partials.text.body1), { color: theme.colors['text-light'] }) })));
const MdUl = styled.ul.withConfig(commonCfg)(({ theme }) => ({
    paddingLeft: theme.spacing.xlarge,
    marginBottom: theme.spacing.small,
}));
const MdOl = styled.ol.withConfig(commonCfg)(({ theme }) => ({
    paddingLeft: theme.spacing.xlarge,
    marginBottom: theme.spacing.small,
}));
const MdLi = styled.li.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body2LooseLineHeight), { marginTop: theme.spacing.xxsmall })));
const MdH1 = styled.h1.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.title2), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdH2 = styled.h2.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.subtitle1), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdH3 = styled.h3.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.subtitle2), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdH4 = styled.h4.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body1Bold), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdH5 = styled.h5.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body1Bold), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdH6 = styled.h6.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body1Bold), { color: theme.colors.text, marginTop: theme.spacing.large, marginBottom: theme.spacing.small, ':first-of-type': { marginTop: 0 } })));
const MdImg = styled.img(() => ({ display: 'inline', maxWidth: '100%' }));
const MdP = styled.p.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body2LooseLineHeight), { marginBottom: theme.spacing.medium })));
const MdDiv = styled.div.withConfig(commonCfg)(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.body2LooseLineHeight), { marginBottom: theme.spacing.medium })));
const MdA = styled.a.withConfig(commonCfg)(({ theme }) => (Object.assign({ display: 'inline' }, theme.partials.text.inlineLink)));
const MdSpan = styled.span.withConfig(commonCfg)(_p => ({
    verticalAlign: 'bottom',
}));
const MdHr = styled.hr.withConfig(commonCfg)(({ theme }) => ({
    '&::before': {
        content: '""',
        display: 'table',
    },
    '&::after': {
        content: '""',
        clear: 'both',
        display: 'table',
    },
    height: '1px',
    backgroundColor: theme.colors.border,
    border: 0,
    padding: 0,
    margin: `${theme.spacing.xlarge}px ${theme.spacing.large}px`,
}));
function MarkdownImage(_a) {
    var { src, gitUrl, style, mainBranch = 'master' } = _a, props = __rest(_a, ["src", "gitUrl", "style", "mainBranch"]);
    // Convert local image paths to full path on github
    // Only works if primary git branch is named "master"
    if (gitUrl && src && !src.match(/^https*/)) {
        src = `${gitUrl}/raw/${mainBranch}/${src}`;
    }
    return (_jsx(MdImg, Object.assign({ src: src, maxWidth: "100%", display: "inline" }, props, { style: Object.assign(Object.assign({}, style), { maxWidth: '100%' }) })));
}
function Markdown({ text, gitUrl, mainBranch }) {
    return useMemo(() => (_jsx(ReactMarkdown, Object.assign({ rehypePlugins: [rehypeRaw], components: {
            blockquote: render({ component: MdBlockquote }),
            ul: render({ component: MdUl }),
            ol: render({ component: MdOl }),
            li: render({ component: MdLi }),
            h1: render({ component: MdH1 }),
            h2: render({ component: MdH2 }),
            h3: render({ component: MdH3 }),
            h4: render({ component: MdH4 }),
            h5: render({ component: MdH5 }),
            h6: render({ component: MdH6 }),
            img: render({
                component: MarkdownImage,
                props: { gitUrl, mainBranch },
            }),
            p: render({ component: MdP }),
            div: render({ component: MdDiv }),
            a: render({ component: MdA, props: { target: '_blank' } }),
            span: render({ component: MdSpan }),
            code: render({ component: InlineCode }),
            pre: render({
                component: MarkdownPreformatted,
                props: { marginBottom: 'medium' },
            }),
            hr: render({ component: MdHr }),
        } }, { children: text }))), [text, gitUrl, mainBranch]);
}
export default Markdown;
//# sourceMappingURL=Markdown.js.map