/// <reference types="react" />
import { ListState } from '@react-stately/list';
import { AriaListBoxOptions } from '@react-aria/listbox';
import { ListBoxUnmanagedProps } from './ListBox';
import { PopoverProps } from './ReactAriaPopover';
import { SelectProps } from './Select';
declare type PopoverListBoxProps = {
    isOpen: boolean;
    onClose: () => void;
    listBoxState: ListState<object>;
    listBoxProps: AriaListBoxOptions<object>;
} & Pick<PopoverProps, 'popoverRef'> & Pick<ListBoxUnmanagedProps, 'listBoxRef'> & Pick<SelectProps, 'width' | 'placement' | 'dropdownHeaderFixed' | 'dropdownFooterFixed'>;
declare function PopoverListBox({ isOpen, onClose, listBoxState, listBoxProps, listBoxRef, popoverRef, dropdownHeaderFixed, dropdownFooterFixed, placement, }: PopoverListBoxProps): JSX.Element;
export { PopoverListBox, PopoverListBoxProps };
