import { jsx as _jsx } from "react/jsx-runtime";
import { useTheme } from 'styled-components';
import { animated, useTransition } from 'react-spring';
import { CSSTransition } from 'react-transition-group';
import { ListBoxUnmanaged } from './ListBox';
import { Popover } from './ReactAriaPopover';
import { PopoverWrapper } from './Select';
function PopoverListBox({ isOpen, onClose, listBoxState, listBoxProps, listBoxRef, popoverRef, dropdownHeaderFixed, dropdownFooterFixed, placement, }) {
    const theme = useTheme();
    const transitions = useTransition(isOpen, {
        from: { opacity: 0, translateY: '-150px' },
        enter: { opacity: 1, translateY: '0' },
        leave: { opacity: 0, translateY: '-150px' },
        config: isOpen
            ? {
                mass: 0.6,
                tension: 280,
                velocity: 0.02,
            }
            : {
                mass: 0.6,
                tension: 400,
                velocity: 0.02,
                restVelocity: 0.1,
            },
    });
    return (_jsx(CSSTransition, Object.assign({ in: isOpen, timeout: 150 }, { children: _jsx(PopoverWrapper, Object.assign({ "$isOpen": isOpen, "$placement": placement, className: "popoverWrapper" }, { children: transitions((styles, item) => item && (_jsx(animated.div, Object.assign({ style: Object.assign({}, styles) }, { children: _jsx(Popover, Object.assign({ popoverRef: popoverRef, isOpen: isOpen, onClose: onClose }, { children: _jsx(ListBoxUnmanaged, Object.assign({ className: "listBox", state: listBoxState, headerFixed: dropdownHeaderFixed, footerFixed: dropdownFooterFixed, extendStyle: {
                            boxShadow: theme.boxShadows.moderate,
                        }, listBoxRef: listBoxRef }, listBoxProps)) })) })))) })) })));
}
export { PopoverListBox };
//# sourceMappingURL=PopoverListBox.js.map