var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, memo, useContext, useEffect, useId, useRef, useState, } from 'react';
import { Label } from 'honorable';
import classNames from 'classnames';
import styled from 'styled-components';
import PropTypes from 'prop-types';
import { useRadio } from '@react-aria/radio';
import { VisuallyHidden } from '@react-aria/visually-hidden';
import { useFocusRing } from '@react-aria/focus';
import { RadioContext } from './RadioGroup';
const CheckedIcon = memo(({ small }) => {
    const checkWidth = small ? 10 : 16;
    const checkRadius = checkWidth / 2;
    return (_jsx("svg", Object.assign({ width: checkWidth, viewBox: `0 0 ${checkWidth} ${checkWidth}`, fill: "none", xmlns: "http://www.w3.org/2000/svg" }, { children: _jsx("circle", { cx: checkRadius, cy: checkRadius, r: checkRadius, fill: "currentColor" }) })));
});
const HonorableLabelStyled = styled(Label)(({ $small = false, $disabled = false, $isFocusVisible, theme, }) => (Object.assign(Object.assign(Object.assign({}, theme.partials.text.body2), { gap: theme.spacing.small, alignItems: 'center', padding: theme.spacing.xxsmall, color: $disabled
        ? theme.colors['text-input-disabled']
        : theme.colors['text-light'], cursor: $disabled ? 'not-allowed' : 'pointer', margin: 0, ':focus': {
        outline: 'none',
    }, '.box': Object.assign(Object.assign({ width: $small ? theme.spacing.medium : theme.spacing.large, height: $small ? theme.spacing.medium : theme.spacing.large, display: 'flex', flexShrink: 0, flexGrow: 0, alignItems: 'center', justifyContent: 'center' }, ($isFocusVisible
        ? Object.assign(Object.assign({}, theme.partials.focus.outline), { border: 'none' }) : {})), { borderRadius: '50%', border: theme.borders.input, borderColor: $disabled
            ? theme.colors['border-disabled']
            : theme.colors['border-input'], backgroundColor: $disabled
            ? theme.colors['action-primary-disabled']
            : $isFocusVisible
                ? theme.colors['action-input-hover']
                : 'transparent', '.icon': {
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            color: $disabled
                ? theme.colors['action-primary-disabled']
                : $isFocusVisible
                    ? theme.colors['action-primary-hover']
                    : theme.colors['action-primary'],
        } }) }), (!$disabled
    ? Object.assign(Object.assign({ ':hover': {
            color: theme.colors.text,
            ':not(.checked) .box': {
                backgroundColor: theme.colors['action-input-hover'],
            },
            '.icon': {
                color: theme.colors['action-primary-hover'],
            },
        } }, ($isFocusVisible
        ? {
            color: theme.colors.text,
            ':not(.checked) .box': {
                backgroundColor: theme.colors['action-input-hover'],
            },
        }
        : {})), { '&.checked': Object.assign({ color: theme.colors.text }, (!$isFocusVisible
            ? {
                '.box': {
                    borderColor: theme.colors['border-selected'],
                },
            }
            : {})) }) : {}))));
function Radio(_a, ref) {
    var { small, value, checked: checkedProp, disabled, defaultChecked, 'aria-describedby': ariaDescribedBy, onChange, onBlur, onFocus, onKeyDown, onKeyUp, name } = _a, props = __rest(_a, ["small", "value", "checked", "disabled", "defaultChecked", 'aria-describedby', "onChange", "onBlur", "onFocus", "onKeyDown", "onKeyUp", "name"]);
    const [checked, setChecked] = useState(defaultChecked || checkedProp);
    const state = useContext(RadioContext) || {
        setSelectedValue: () => { },
        selectedValue: checkedProp || checked ? value : undefined,
    };
    useEffect(() => {
        setChecked(checkedProp);
    }, [checkedProp]);
    const labelId = useId();
    const inputRef = useRef();
    const { isFocusVisible, focusProps } = useFocusRing();
    const { inputProps, isSelected, isDisabled } = useRadio({
        value,
        'aria-describedby': ariaDescribedBy,
        'aria-labelledby': labelId,
        isDisabled: disabled,
        onBlur,
        onFocus,
        onKeyDown,
        onKeyUp,
    }, state, inputRef);
    const icon = isSelected ? _jsx(CheckedIcon, { small: small }) : null;
    return (_jsxs(HonorableLabelStyled, Object.assign({ htmlFor: inputProps.id, id: labelId, ref: ref, className: classNames({ checked: isSelected }), "$isFocusVisible": isFocusVisible, "$small": small, "$disabled": isDisabled, display: "flex", marginBottom: "0" }, props, { children: [_jsx(VisuallyHidden, { children: _jsx("input", Object.assign({}, inputProps, focusProps, { name: inputProps.name || name, onChange: e => {
                        if (typeof onChange === 'function') {
                            onChange(e);
                        }
                        setChecked(!checked);
                        inputProps.onChange(e);
                    }, ref: inputRef })) }), _jsx("div", Object.assign({ className: "box" }, { children: _jsx("div", Object.assign({ className: "icon" }, { children: icon })) })), _jsxs("div", Object.assign({ className: "label" }, { children: [" ", props.children] }))] })));
}
Radio.propTypes = {
    small: PropTypes.bool,
};
export default forwardRef(Radio);
//# sourceMappingURL=Radio.js.map