var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useRef } from 'react';
import { DismissButton, useOverlay } from '@react-aria/overlays';
import { FocusScope } from '@react-aria/focus';
import styled from 'styled-components';
function Popover(_a) {
    var props = __rest(_a, []);
    const ref = useRef();
    const { popoverRef = ref, isOpen, onClose, children, } = props;
    // Handle events that should cause the popup to close,
    // e.g. blur, clicking outside, or pressing the escape key.
    const { overlayProps } = useOverlay({
        isOpen,
        onClose,
        shouldCloseOnBlur: true,
        isDismissable: true,
    }, popoverRef);
    // Need to remove ref and change key when closed so react-aria thinks the
    // Popover has unmounted when animating out
    let content = (_jsxs(PopoverStyled, Object.assign({ className: "popover", "$isOpen": isOpen }, overlayProps, (isOpen && {
        ref: popoverRef,
    }), { children: [children, _jsx(DismissButton, { onDismiss: onClose })] }), isOpen ? 'open' : 'closed'));
    content = _jsx(FocusScope, Object.assign({ restoreFocus: true }, { children: content }));
    return content;
}
const PopoverStyled = styled.div(({ $isOpen: isOpen }) => (Object.assign({ display: 'flex', position: 'absolute', width: '100%', marginTop: 4, '> *': {
        flexGrow: 1,
    } }, (!isOpen ? { pointerEvents: 'none' } : {}))));
export { Popover };
//# sourceMappingURL=ReactAriaPopover.js.map