var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Div, Flex, H1, H3, Img, P, Span, } from 'honorable';
import PropTypes from 'prop-types';
import { forwardRef } from 'react';
import Chip from './Chip';
import PadlockLockedIcon from './icons/PadlockLockedIcon';
import VerifiedIcon from './icons/VerifiedIcon';
import Card from './Card';
import RocketIcon from './icons/RocketIcon';
const propTypes = {
    title: PropTypes.string,
    publisher: PropTypes.string,
    priv: PropTypes.bool,
    installed: PropTypes.bool,
    verified: PropTypes.bool,
    trending: PropTypes.bool,
    description: PropTypes.string,
    imageUrl: PropTypes.string,
    tags: PropTypes.arrayOf(PropTypes.string),
    size: PropTypes.oneOf(['small', 'medium', 'large']),
};
function RepositoryCardRef(_a, ref) {
    var { title, publisher, priv, installed, verified, trending, description, imageUrl, tags = [], size = 'small' } = _a, props = __rest(_a, ["title", "publisher", "priv", "installed", "verified", "trending", "description", "imageUrl", "tags", "size"]);
    const maxTags = trending ? 5 : 6;
    return (_jsx(Card, Object.assign({ ref: ref, clickable: true, flexDirection: "column", padding: "large", width: "100%" }, props, { children: _jsxs(Flex, Object.assign({ height: "100%", align: "flex-start" }, { children: [_jsx(Img, { src: imageUrl, width: size === 'medium' ? 140 : 160, height: size === 'medium' ? 140 : 160, display: size === 'small' ? 'none' : 'block', padding: "xlarge", backgroundColor: "fill-two", borderRadius: "medium", border: "1px solid border-fill-two", marginRight: "large" }), _jsxs(Flex, Object.assign({ flexGrow: 1, direction: "column", height: "100%" }, { children: [_jsxs(Flex, Object.assign({ align: "center" }, { children: [_jsx(Img, { src: imageUrl, width: 64, height: 64, padding: "xsmall", display: size === 'small' ? 'block' : 'none', backgroundColor: "fill-two", borderRadius: "medium", border: "1px solid border-fill-two" }), _jsxs(Flex, Object.assign({ direction: "row", marginLeft: size === 'small' ? 'small' : 0, width: "100%", align: "flex-start", justify: "space-between" }, { children: [_jsxs(Flex, Object.assign({ direction: "column" }, { children: [_jsxs(H1, Object.assign({ color: "text", title2: size !== 'large', title1: size === 'large' }, { children: [title, !!verified && (_jsx(VerifiedIcon, { color: "action-link-inline", size: 12, position: "relative", bottom: 10, left: 4 }))] })), _jsx(H3, Object.assign({ body2: true, color: "text-xlight", marginBottom: size === 'large' ? 'small' : 0 }, { children: publisher }))] })), _jsxs(Flex, Object.assign({ justifyContent: "end", flexGrow: 1, marginLeft: "medium" }, { children: [!!installed && (_jsx(Chip, Object.assign({ severity: "success", size: "large", hue: "lighter" }, { children: _jsx(Span, Object.assign({ fontWeight: 600 }, { children: "Installed" })) }))), !!priv && (_jsx(Chip, Object.assign({ size: "large", hue: "lighter", marginLeft: 8, paddingHorizontal: 8, paddingVertical: 8, backgroundColor: "transparent", border: "none" }, { children: _jsx(PadlockLockedIcon, {}) })))] }))] }))] })), description && (_jsx(P, Object.assign({ body2: true, marginTop: "xsmall", color: "text-light", style: {
                                display: '-webkit-box',
                                '-webkit-line-clamp': '2',
                                '-webkit-box-orient': 'vertical',
                                overflow: 'hidden',
                            } }, { children: description }))), _jsx(Div, { flexGrow: 1 }), (trending || (tags === null || tags === void 0 ? void 0 : tags.length) > 0) && (_jsxs(Flex, Object.assign({ marginTop: "medium", gap: "xsmall", flexWrap: "wrap" }, { children: [!!trending && (_jsxs(Chip, Object.assign({ size: "small", hue: "lighter" }, { children: [_jsx(RocketIcon, { color: "action-link-inline" }), _jsx(Span, Object.assign({ color: "action-link-inline", marginLeft: "xxsmall" }, { children: "Trending" }))] }))), tags === null || tags === void 0 ? void 0 : tags.filter((_x, i) => i < maxTags).map(tag => (_jsx(Chip, Object.assign({ size: "small", hue: "lighter", _last: { marginRight: 0 } }, { children: tag }), tag)))] })))] }))] })) })));
}
const RepositoryCard = forwardRef(RepositoryCardRef);
RepositoryCard.propTypes = propTypes;
export default RepositoryCard;
//# sourceMappingURL=RepositoryCard.js.map