import { HTMLAttributes, ReactElement, ReactNode } from 'react';
import { AriaSelectProps } from '@react-types/select';
import { ListBoxItemBaseProps } from './ListBoxItem';
import { setNextFocusedKey } from './SelectComboShared';
declare type SelectButtonProps = {
    leftContent?: ReactNode;
    rightContent?: ReactNode;
    children?: ReactNode;
    showArrow?: boolean;
    isOpen?: boolean;
};
declare type Placement = 'left' | 'right';
export declare type SelectProps = Exclude<SelectButtonProps, 'children'> & {
    children: ReactElement<ListBoxItemBaseProps> | ReactElement<ListBoxItemBaseProps>[];
    dropdownHeaderFixed?: ReactNode;
    dropdownFooterFixed?: ReactNode;
    dropdownHeader?: ReactElement;
    dropdownFooter?: ReactElement;
    onHeaderClick?: () => unknown;
    onFooterClick?: () => unknown;
    triggerButton?: ReactElement;
    placement?: Placement;
    width?: string | number;
    maxHeight?: string | number;
} & Omit<AriaSelectProps<object>, 'autoFocus' | 'onLoadMore' | 'isLoading' | 'validationState' | 'placeholder'>;
declare const SelectButtonInner: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    $isOpen: boolean;
}, never>;
declare const SelectButton: import("react").ComponentType<SelectButtonProps & HTMLAttributes<HTMLDivElement> & import("react").RefAttributes<HTMLDivElement>>;
declare const SelectInner: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    $isOpen: boolean;
    $maxHeight: string | number;
    $placement: Placement;
    $width?: string | number;
}, never>;
declare function Select({ children, selectedKey, onSelectionChange, isOpen, onOpenChange, leftContent, rightContent, dropdownHeader, dropdownFooter, dropdownHeaderFixed, dropdownFooterFixed, onHeaderClick, onFooterClick, label, name, triggerButton, placement, width, maxHeight, ...props }: SelectProps): JSX.Element;
export declare const PopoverWrapper: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    $isOpen: boolean;
    $placement: Placement;
}, never>;
export { Select, SelectButton, SelectButtonInner, SelectInner, setNextFocusedKey, };
