var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { cloneElement, forwardRef, useRef, useState, } from 'react';
import { HiddenSelect, useSelect } from '@react-aria/select';
import { useSelectState } from '@react-stately/select';
import { useButton } from '@react-aria/button';
import styled, { useTheme } from 'styled-components';
import DropdownArrowIcon from './icons/DropdownArrowIcon';
import { PopoverListBox } from './PopoverListBox';
import { setNextFocusedKey, useSelectComboStateProps } from './SelectComboShared';
function Trigger(_a) {
    var { buttonElt, isOpen } = _a, props = __rest(_a, ["buttonElt", "isOpen"]);
    const ref = props.buttonRef;
    const { buttonProps } = useButton(props, ref);
    const theme = useTheme();
    return cloneElement(buttonElt, Object.assign(Object.assign({ ref }, buttonProps), { isOpen, style: Object.assign({ appearance: 'unset' }, (isOpen ? { zIndex: theme.zIndexes.tooltip + 1 } : {})), tabIndex: 0 }));
}
const SelectButtonInner = styled.div(({ theme, $isOpen: isOpen }) => (Object.assign(Object.assign(Object.assign({}, theme.partials.reset.button), theme.partials.text.body2), { display: 'flex', flexDirection: 'row', flexShrink: 1, alignItems: 'center', width: '100%', padding: `9px ${theme.spacing.medium}px`, color: theme.colors['text-light'], border: theme.borders.input, borderRadius: theme.borderRadiuses.medium, '.children': {
        flexGrow: 1,
    }, '.leftContent, .rightContent': {
        display: 'flex',
        alignItems: 'center',
    }, '.leftContent': {
        marginRight: theme.spacing.medium,
    }, '.rightContent': {
        marginLeft: theme.spacing.medium,
    }, '.arrow': Object.assign({ transition: 'transform 0.1s ease', display: 'flex', marginLeft: theme.spacing.medium, alignItems: 'center' }, theme.partials.dropdown.arrowTransition({ isOpen })), '&:focus-visible': Object.assign({}, theme.partials.focus.default) })));
const SelectButton = forwardRef((_a, ref) => {
    var { leftContent, rightContent, children, showArrow = true, isOpen } = _a, props = __rest(_a, ["leftContent", "rightContent", "children", "showArrow", "isOpen"]);
    return (_jsxs(SelectButtonInner, Object.assign({ ref: ref, "$isOpen": isOpen }, props, { children: [leftContent && _jsx("div", Object.assign({ className: "leftContent" }, { children: leftContent })), _jsx("div", Object.assign({ className: "children" }, { children: children })), rightContent && _jsx("div", Object.assign({ className: "rightContent" }, { children: rightContent })), showArrow && (_jsx("div", Object.assign({ className: "arrow" }, { children: _jsx(DropdownArrowIcon, { size: 16 }) })))] })));
});
const SelectInner = styled.div(({ $maxHeight: maxHeight, $placement: placement, $width: width }) => ({
    position: 'relative',
    '.popover': Object.assign(Object.assign({ maxHeight: maxHeight || 230, width: width || '100%' }, (placement === 'right' && { right: 0, left: 'auto' })), { pointerEvents: 'auto' }),
}));
function Select(_a) {
    var _b, _c, _d, _e;
    var { children, selectedKey, onSelectionChange, isOpen, onOpenChange, leftContent, rightContent, dropdownHeader, dropdownFooter, dropdownHeaderFixed, dropdownFooterFixed, onHeaderClick, onFooterClick, label, name, triggerButton, placement, width, maxHeight } = _a, props = __rest(_a, ["children", "selectedKey", "onSelectionChange", "isOpen", "onOpenChange", "leftContent", "rightContent", "dropdownHeader", "dropdownFooter", "dropdownHeaderFixed", "dropdownFooterFixed", "onHeaderClick", "onFooterClick", "label", "name", "triggerButton", "placement", "width", "maxHeight"]);
    const stateRef = useRef(null);
    const [isOpenUncontrolled, setIsOpen] = useState(false);
    const nextFocusedKeyRef = useRef(null);
    if (typeof isOpen !== 'boolean') {
        isOpen = isOpenUncontrolled;
    }
    const selectStateBaseProps = useSelectComboStateProps({
        dropdownHeader,
        dropdownFooter,
        onFooterClick,
        onHeaderClick,
        onOpenChange,
        onSelectionChange,
        children,
        setIsOpen,
        stateRef,
        nextFocusedKeyRef,
    });
    const selectStateProps = Object.assign(Object.assign(Object.assign({}, selectStateBaseProps), { isOpen, defaultOpen: false, selectedKey,
        label }), props);
    const state = useSelectState(selectStateProps);
    setNextFocusedKey({ nextFocusedKeyRef, state, stateRef });
    // Get props for the listbox element
    const ref = useRef();
    const { triggerProps, menuProps } = useSelect(selectStateProps, state, ref);
    label = label || ' ';
    triggerButton = triggerButton || (_jsx(SelectButton, Object.assign({ className: "triggerButton", leftContent: leftContent, rightContent: rightContent, isOpen: state.isOpen }, { children: ((_e = (_d = (_c = (_b = state.selectedItem) === null || _b === void 0 ? void 0 : _b.props) === null || _c === void 0 ? void 0 : _c.children) === null || _d === void 0 ? void 0 : _d.props) === null || _e === void 0 ? void 0 : _e.label) || label })));
    return (_jsxs(SelectInner, Object.assign({ className: "selectInner", "$isOpen": state.isOpen, "$maxHeight": maxHeight, "$width": width, "$placement": placement }, { children: [_jsx(HiddenSelect, { state: state, triggerRef: ref, label: label, name: name }), _jsx(Trigger, Object.assign({ buttonRef: ref, buttonElt: triggerButton, isOpen: state.isOpen }, triggerProps)), _jsx(PopoverListBox, { isOpen: state.isOpen, onClose: state.close, listBoxState: state, listBoxProps: menuProps, dropdownHeaderFixed: dropdownHeaderFixed, dropdownFooterFixed: dropdownFooterFixed, width: width, placement: placement })] })));
}
export const PopoverWrapper = styled.div(({ theme, $placement: placement }) => (Object.assign(Object.assign({ position: 'absolute', width: '100%' }, (placement === 'right' && { right: 0, left: 'auto' })), { pointerEvents: 'none', zIndex: theme.zIndexes.selectPopover, clipPath: 'polygon(-100px 0, -100px 99999px, 99999px 99999px, 99999px 0)', '&.enter-done': {
        clipPath: 'none',
    } })));
export { Select, SelectButton, SelectButtonInner, SelectInner, setNextFocusedKey, };
//# sourceMappingURL=Select.js.map