import { Dispatch, Key, MutableRefObject, RefObject, SetStateAction } from 'react';
import { ListState } from '@react-stately/list';
import { useItemWrappedChildren } from './ListBox';
import { ComboBoxProps } from './ComboBox';
import { SelectProps } from './Select';
declare type TType = SelectProps | ComboBoxProps;
declare type UseSelectComboStatePropsArgs<T extends TType> = Pick<T, 'onSelectionChange' | 'onOpenChange' | 'dropdownHeader' | 'dropdownFooter' | 'onFooterClick' | 'onHeaderClick' | 'children'> & {
    setIsOpen: Dispatch<SetStateAction<boolean>>;
    stateRef: RefObject<ListState<object> | null>;
    nextFocusedKeyRef: MutableRefObject<Key>;
};
declare type UseSelectComboStatePropsReturn<T extends TType> = Pick<T, 'children' | 'onOpenChange' | 'onSelectionChange'>;
declare function useSelectComboStateProps<T extends TType>({ setIsOpen, onOpenChange, onFooterClick, onHeaderClick, onSelectionChange, dropdownHeader, dropdownFooter, stateRef, children, nextFocusedKeyRef, }: UseSelectComboStatePropsArgs<T>): UseSelectComboStatePropsReturn<T>;
declare const setNextFocusedKey: ({ nextFocusedKeyRef, state, stateRef, }: {
    nextFocusedKeyRef: MutableRefObject<Key>;
    state: ListState<object>;
    stateRef: MutableRefObject<ListState<object>>;
}) => void;
export { useSelectComboStateProps, setNextFocusedKey, useItemWrappedChildren };
