var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Flex } from 'honorable';
import PropTypes from 'prop-types';
import { forwardRef } from 'react';
import Tooltip from '../components/Tooltip';
const propTypes = {
    clickable: PropTypes.bool,
    tooltip: PropTypes.string,
    href: PropTypes.string,
};
const styles = {
    ':first-of-type': {
        marginTop: 0,
    },
};
function SidebarItemRef(_a, ref) {
    var { children, clickable = false, tooltip = '', href = '' } = _a, props = __rest(_a, ["children", "clickable", "tooltip", "href"]);
    return (_jsx(WithTooltip, Object.assign({ tooltip: tooltip }, { children: _jsx(WithLink, Object.assign({ href: href }, { children: _jsx(Item, Object.assign({ clickable: clickable, ref: ref }, props, { children: children })) })) })));
}
function withTooltipRef(_a, ref) {
    var { children, clickable, tooltip = '' } = _a, props = __rest(_a, ["children", "clickable", "tooltip"]);
    if (!tooltip)
        return (_jsxs(_Fragment, { children: [" ", children] }));
    return (_jsx(Tooltip, Object.assign({ arrow: true, placement: "right", label: tooltip, whiteSpace: "nowrap" }, { children: _jsx(Item, Object.assign({ clickable: clickable, ref: ref }, props, { children: children })) })));
}
function withLinkRef(_a, ref) {
    var { children, clickable, href = '' } = _a, props = __rest(_a, ["children", "clickable", "href"]);
    if (!href)
        return (_jsxs(_Fragment, { children: [" ", children] }));
    return (_jsx("a", Object.assign({ href: href, target: "_blank", rel: "noreferrer" }, { children: _jsx(Item, Object.assign({ clickable: clickable, ref: ref }, props, { children: children })) })));
}
function ItemRef(_a, ref) {
    var { children, clickable = false } = _a, props = __rest(_a, ["children", "clickable"]);
    return (_jsx(Flex, Object.assign({ grow: 0, justify: "center", alignItems: "center", marginTop: "xsmall", width: 32, height: 32, _hover: clickable && {
            backgroundColor: 'fill-one-hover',
            borderRadius: '3px',
            cursor: 'pointer',
            overflow: 'hidden',
        }, color: "text", ref: ref }, styles, props, { children: children })));
}
const SidebarItem = forwardRef(SidebarItemRef);
const Item = forwardRef(ItemRef);
const WithTooltip = forwardRef(withTooltipRef);
const WithLink = forwardRef(withLinkRef);
SidebarItem.propTypes = propTypes;
export default SidebarItem;
//# sourceMappingURL=SidebarItem.js.map