var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Div, Flex, H1, H3, P, } from 'honorable';
import PropTypes from 'prop-types';
import { forwardRef } from 'react';
import Card from './Card';
import AppIcon from './AppIcon';
import Tooltip from './Tooltip';
import Chip from './Chip';
import StackIcon from './icons/StackIcon';
const hueToColor = {
    neutral: 'border',
    red: 'text-danger-light',
    green: 'text-success-light',
    blue: 'border-outline-focused',
    yellow: 'text-warning-light',
};
const propTypes = {
    title: PropTypes.string,
    description: PropTypes.string,
    apps: PropTypes.arrayOf(PropTypes.shape({
        name: PropTypes.string.isRequired,
        imageUrl: PropTypes.string.isRequired,
    }).isRequired).isRequired,
    hue: PropTypes.oneOf([
        'neutral',
        'red',
        'green',
        'blue',
        'yellow',
    ]),
};
function StackCardRef(_a, ref) {
    var { title, description, apps = [], hue = 'neutral' } = _a, props = __rest(_a, ["title", "description", "apps", "hue"]);
    return (_jsx(Card, Object.assign({ ref: ref, clickable: true, flexDirection: "column", padding: "large", width: "100%", borderColor: hueToColor[hue], fillLevel: 1 }, props, { children: _jsx(Flex, Object.assign({ height: "100%", align: "flex-start" }, { children: _jsxs(Flex, Object.assign({ flexGrow: 1, direction: "column", height: "100%" }, { children: [_jsx(Flex, Object.assign({ align: "center" }, { children: _jsxs(Flex, Object.assign({ direction: "row", width: "100%", align: "flex-start", justify: "space-between" }, { children: [_jsxs(Flex, Object.assign({ direction: "column" }, { children: [_jsx(H1, Object.assign({ subtitle1: true, color: "text", marginBottom: "xxsmall" }, { children: title })), _jsxs(H3, Object.assign({ body2: true, fontWeight: "300", color: "text-xlight", marginBottom: "xxsmall" }, { children: [(apps === null || apps === void 0 ? void 0 : apps.length) || 0, " APP", (apps === null || apps === void 0 ? void 0 : apps.length) !== 1 && 'S'] }))] })), _jsx(Chip, Object.assign({ icon: _jsx(StackIcon, {}) }, { children: "Stack" }))] })) })), description && (_jsx(P, Object.assign({ body2: true, fontWeight: "300", color: "text-light", marginTop: "xsmall", style: {
                            display: '-webkit-box',
                            '-webkit-line-clamp': '2',
                            '-webkit-box-orient': 'vertical',
                            overflow: 'hidden',
                        } }, { children: description }))), _jsx(Div, { flexGrow: 1 }), (apps === null || apps === void 0 ? void 0 : apps.length) > 0 && (_jsx(Flex, Object.assign({ marginTop: "medium", gap: "xsmall", flexWrap: "wrap" }, { children: apps
                            .map((app, i) => (_jsx(Tooltip, Object.assign({ label: app.name, placement: "bottom" }, { children: _jsx(AppIcon, { alt: app.name, url: app.imageUrl, size: "xxsmall", hue: "lighter" }) }), i))) })))] })) })) })));
}
const StackCard = forwardRef(StackCardRef);
StackCard.propTypes = propTypes;
export default StackCard;
//# sourceMappingURL=StackCard.js.map