var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Div, Flex, } from 'honorable';
import { Fragment, forwardRef, useCallback, useEffect, useRef, useState, } from 'react';
import PropTypes from 'prop-types';
import { mergeRefs } from '@react-aria/utils';
import { useTheme } from 'styled-components';
import useResizeObserver from '../hooks/useResizeObserver';
import StatusOkIcon from './icons/StatusOkIcon';
import Tooltip from './Tooltip';
import WrapWithIf from './WrapWithIf';
const propTypes = {
    stepIndex: PropTypes.number.isRequired,
    steps: PropTypes.arrayOf(PropTypes.shape({
        stepTitle: PropTypes.node.isRequired,
        IconComponent: PropTypes.elementType.isRequired,
        iconSize: PropTypes.number,
    }).isRequired).isRequired,
};
function Step(_a) {
    var { isActive = false, isComplete = false, stepTitle, IconComponent, iconSize = 24, circleSize = 48, vertical = false, collapseTitles = false } = _a, props = __rest(_a, ["isActive", "isComplete", "stepTitle", "IconComponent", "iconSize", "circleSize", "vertical", "collapseTitles"]);
    const theme = useTheme();
    const bounceEase = 'cubic-bezier(.37,1.4,.62,1)';
    const shownClassName = 'shown';
    const completeIconStyles = {
        opacity: '0',
        transform: 'scale(0)',
        transition: 'all 0.2s ease',
        [`&.${shownClassName}`]: {
            transform: 'scale(1)',
            opacity: '1',
            transition: `transform 0.3s ${bounceEase}, opacity 0.1s ease`,
            transitionDelay: '0.1s',
        },
    };
    return (_jsxs(Flex, Object.assign({ width: "100%", minWidth: "68px", maxWidth: vertical ? '100%' : '100px', direction: vertical ? 'row' : 'column', align: "center" }, props, { children: [_jsx(WrapWithIf, Object.assign({ condition: collapseTitles, wrapper: _jsx(Tooltip, { label: stepTitle }) }, { children: _jsxs(Div, Object.assign({ position: "relative", width: circleSize, height: circleSize, marginLeft: vertical ? 'none' : 'auto', marginRight: vertical ? 'none' : 'auto', borderRadius: 1000, backgroundColor: theme.colors['fill-one'], border: `1px solid ${isActive ? theme.colors['border-selected'] : theme.colors.border}`, transition: "all 0.2s ease", transitionDelay: "0.1", flexShrink: 0 }, { children: [_jsx(Flex, Object.assign({ width: "100%", height: "100%", position: "absolute", justifyContent: "center", alignItems: "center", className: isComplete ? '' : shownClassName }, completeIconStyles, { children: _jsx(IconComponent, { size: iconSize, color: isActive ? theme.colors['icon-default'] : theme.colors['icon-xlight'] }) })), _jsx(Flex, Object.assign({ width: "100%", height: "100%", position: "absolute", justifyContent: "center", alignItems: "center", className: isComplete ? shownClassName : '' }, completeIconStyles, { children: _jsx(StatusOkIcon, { color: theme.colors['icon-success'], size: 24 }) }))] })) })), !collapseTitles && (_jsx(Div, Object.assign({ body2: true, marginTop: vertical ? 'none' : 'small', marginLeft: vertical ? 'small' : 'none', textAlign: vertical ? 'left' : 'center', color: isActive ? theme.colors.text : theme.colors['text-xlight'], transition: "all 0.2s ease", transitionDelay: "0.1", flexShrink: vertical ? 1 : 0 }, { children: stepTitle })))] })));
}
function StepConnection(_a) {
    var { isActive = false, vertical = false } = _a, props = __rest(_a, ["isActive", "vertical"]);
    const theme = useTheme();
    return (_jsx(Div, Object.assign({ width: vertical ? 1 : '100%', height: vertical ? 30 : 1, flexGrow: 1, backgroundColor: theme.colors.border, position: "relative", "aria-hidden": "true" }, props, { children: _jsx(Div, { width: vertical ? 1 : isActive ? '100%' : 0, height: vertical ? (isActive ? 30 : 0) : '100%', position: "absolute", left: 0, top: 0, backgroundColor: theme.colors['border-selected'], transition: "width 0.1s ease-out, height 0.1s ease-out" }) })));
}
function StepperRef({ stepIndex, steps, vertical = false, collapseAtWidth = 160, forceCollapse = false, }, ref) {
    const circleSize = 48;
    const eltRef = useRef();
    const mergedRef = mergeRefs(ref, eltRef);
    const [collapseTitles, setCollapseTitles] = useState(true);
    const attemptCollapse = useCallback(() => {
        var _a;
        if (vertical && forceCollapse) {
            setCollapseTitles(true);
            return;
        }
        setCollapseTitles(forceCollapse || ((_a = eltRef === null || eltRef === void 0 ? void 0 : eltRef.current) === null || _a === void 0 ? void 0 : _a.clientWidth) < collapseAtWidth);
    }, [forceCollapse, eltRef, collapseAtWidth, vertical]);
    useEffect(attemptCollapse, [vertical, forceCollapse, attemptCollapse]);
    useResizeObserver(eltRef, attemptCollapse);
    return (_jsx(Flex, Object.assign({ ref: mergedRef, width: "100%", direction: vertical ? 'column' : 'row', justifyContent: "space-between", overflow: "hidden" }, { children: steps.map((step, index) => (_jsxs(Fragment, { children: [_jsx(Step, { isActive: stepIndex === index, isComplete: stepIndex > index, stepTitle: step.stepTitle, IconComponent: step.IconComponent, iconSize: step.iconSize || 24, circleSize: 48, vertical: vertical, collapseTitles: vertical && collapseTitles }), index < steps.length - 1 && (_jsx(StepConnection, { isActive: stepIndex > index, vertical: vertical, marginTop: vertical ? 'small' : circleSize / 2, marginBottom: vertical ? 'small' : 'none', marginLeft: vertical ? 'large' : 'none' }))] }, step.key))) })));
}
const Stepper = forwardRef(StepperRef);
// @ts-expect-error
Stepper.propTypes = propTypes;
export default Stepper;
//# sourceMappingURL=Stepper.js.map