var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { forwardRef } from 'react';
import styled from 'styled-components';
import { useFillLevel } from './contexts/FillLevelContext';
const parentFillLevelToActiveBG = {
    0: 'fill-zero-selected',
    1: 'fill-one-selected',
    2: 'fill-two-selected',
    3: 'fill-three-selected',
};
const SubTabBase = styled.div(({ theme, active, size, parentFillLevel, }) => (Object.assign(Object.assign({}, (size === 'small'
    ? theme.partials.text.buttonSmall
    : theme.partials.text.buttonMedium)), { tabIndex: 0, userSelect: 'none', cursor: 'pointer', color: active ? theme.colors.text : theme.colors['text-xlight'], backgroundColor: active
        ? theme.colors[parentFillLevelToActiveBG[parentFillLevel]]
        : 'transparent', borderRadius: theme.borderRadiuses.medium, focusVisible: Object.assign({ zIndex: theme.zIndexes.base + 1 }, theme.partials.focus.default), padding: `${size === 'small' ? theme.spacing.xxsmall : theme.spacing.xsmall}px ${theme.spacing.medium}px`, align: 'center', hover: {
        backgroundColor: parentFillLevel >= 2
            ? theme.colors['fill-two-hover']
            : theme.colors['fill-one-hover'],
    }, transition: 'background-color 150ms ease, border-color 150ms ease, color 150ms ease', '.codeTabInner': {} })));
function SubTabRef(_a, ref) {
    var { active, children, textValue: _textValue, size = 'medium' } = _a, props = __rest(_a, ["active", "children", "textValue", "size"]);
    const parentFillLevel = useFillLevel();
    return (_jsx(SubTabBase, Object.assign({ parentFillLevel: parentFillLevel, active: active, ref: ref, size: size }, props, { children: children })));
}
export const SubTab = forwardRef(SubTabRef);
export default SubTab;
//# sourceMappingURL=SubTab.js.map