var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { Flex } from 'honorable';
import { useTab, useTabList } from '@react-aria/tabs';
import { useTabListState } from '@react-stately/tabs';
import { Children, cloneElement, forwardRef, useEffect, useMemo, useRef, } from 'react';
import styled, { useTheme } from 'styled-components';
import { mergeRefs } from '@react-aria/utils';
import { useItemWrappedChildren } from './ListBox';
function TabListRef(_a, incomingRef) {
    var _b;
    var { stateRef, stateProps, renderer, as } = _a, props = __rest(_a, ["stateRef", "stateProps", "renderer", "as"]);
    const wrappedChildren = useItemWrappedChildren(props.children);
    const finalStateProps = useMemo(() => (Object.assign({
        keyboardActivation: 'manual',
        orientation: 'horizontal',
        children: [...wrappedChildren],
    }, stateProps)), [stateProps, wrappedChildren]);
    const state = useTabListState(finalStateProps);
    stateRef.current = Object.assign(Object.assign({ updateTabPanel: () => {
            console.warn("TabPanel didn't set stateRef.current.updateTabPanel");
        } }, (stateRef.current || {})), { state, stateProps: finalStateProps, tabProps: ((_b = stateRef === null || stateRef === void 0 ? void 0 : stateRef.current) === null || _b === void 0 ? void 0 : _b.tabProps) || {} });
    useEffect(() => {
        var _a;
        (_a = stateRef === null || stateRef === void 0 ? void 0 : stateRef.current) === null || _a === void 0 ? void 0 : _a.updateTabPanel();
    });
    const ref = useRef(null);
    const mergedRef = mergeRefs(ref, incomingRef);
    const { tabListProps } = useTabList(finalStateProps, state, ref);
    const tabChildren = [...state.collection].map(item => (_jsx(TabRenderer, { item: item, state: state, stateProps: finalStateProps, stateRef: stateRef }, item.key)));
    if (as) {
        return cloneElement(as, Object.assign(Object.assign(Object.assign(Object.assign({}, tabListProps), as.props), { children: tabChildren }), { ref: mergedRef }));
    }
    if (renderer) {
        return renderer(Object.assign(Object.assign(Object.assign({}, props), tabListProps), { children: tabChildren }), mergedRef, state);
    }
    return (_jsx(Flex, Object.assign({}, tabListProps, props, { flexDirection: stateProps.orientation === 'vertical' ? 'column' : 'row', alignItems: stateProps.orientation === 'vertical' ? 'flex-start' : 'flex-end', ref: mergedRef }, { children: tabChildren })));
}
const TabList = forwardRef(TabListRef);
const TabClone = styled((_a) => {
    var { className, children, tabRef } = _a, props = __rest(_a, ["className", "children", "tabRef"]);
    return cloneElement(Children.only(children), Object.assign({ className: `${children.props.className || ''} ${className || ''}`.trim(), ref: tabRef }, props));
})(({ theme, vertical }) => (Object.assign({ position: 'relative', '&:focus, &:focus-visible': {
        outline: 'none',
        zIndex: theme.zIndexes.base + 1,
    }, '&:focus-visible': Object.assign({}, theme.partials.focus.default) }, (vertical
    ? {
        width: '100%',
    }
    : {}))));
function TabRenderer({ item, state, stateProps, stateRef, }) {
    const ref = useRef(null);
    const { tabProps: props } = useTab({ key: item.key }, state, ref);
    props['aria-controls']
        = props['aria-controls'] || props.id.replace('-tab-', '-tabpanel-');
    stateRef.current.tabProps = Object.assign(Object.assign({}, stateRef.current.tabProps), {
        [item.key]: Object.assign({}, props),
    });
    const theme = useTheme();
    if (item.props.renderer) {
        return item.props.renderer(Object.assign({
            cursor: 'pointer',
            _focusVisible: Object.assign({}, theme.partials.focus.default),
            position: 'relative',
            '&:focus, &:focus-visible': {
                zIndex: theme.zIndexes.base + 1,
            },
        }, props), ref, state);
    }
    return (_jsx(TabClone, Object.assign({ tabRef: ref }, props, { active: state.selectedKey === item.key, vertical: stateProps.orientation === 'vertical' }, item.props, { children: item.rendered })));
}
export { TabList, };
//# sourceMappingURL=TabList.js.map