var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { Div } from 'honorable';
import { useTabPanel } from '@react-aria/tabs';
import { cloneElement, forwardRef, useCallback, useEffect, useReducer, useRef, } from 'react';
import { mergeProps, mergeRefs } from '@react-aria/utils';
import styled from 'styled-components';
import { useVisuallyHidden } from '@react-aria/visually-hidden';
export const TabPanelClone = styled((_a) => {
    var { className, cloneAs, tabRef } = _a, props = __rest(_a, ["className", "cloneAs", "tabRef"]);
    return cloneElement(cloneAs, Object.assign({ className: `${cloneAs.props.className || ''} ${className || ''}`.trim(), ref: tabRef }, props));
})(({ theme }) => ({
    position: 'relative',
    '&:focus, &:focus-visible': {
        outline: 'none',
        zIndex: theme.zIndexes.base + 1,
    },
}));
function WrappedTabPanel(_a) {
    var { stateRef: { current: { state, stateProps, tabProps }, }, renderer, as, tabKey, mode } = _a, props = __rest(_a, ["stateRef", "renderer", "as", "tabKey", "mode"]);
    const ref = useRef();
    let { tabPanelProps } = useTabPanel(stateProps, state, ref);
    const { visuallyHiddenProps } = useVisuallyHidden();
    if (mode === 'multipanel') {
        const thisTabProps = tabProps[tabKey];
        if (!thisTabProps) {
            console.warn('Unable to find props for TabPanel. Did you forget to create a TabList?');
        }
        tabPanelProps = Object.assign({ 'aria-labelledby': thisTabProps.id, id: thisTabProps['aria-controls'] }, (state.selectedKey !== tabKey
            ? Object.assign(Object.assign({}, visuallyHiddenProps), { 'aria-hidden': true }) : {}));
    }
    if (renderer) {
        return renderer(mergeProps(tabPanelProps, props), ref, state);
    }
    const mergedProps = mergeProps(tabPanelProps, as.props, {
        children: props.children,
    });
    return (_jsx(TabPanelClone, Object.assign({ tabRef: mergeRefs(as.ref, ref), cloneAs: as }, mergedProps)));
}
const TabPanel = forwardRef((_a, ref) => {
    var { as, renderer, stateRef, tabKey, mode } = _a, props = __rest(_a, ["as", "renderer", "stateRef", "tabKey", "mode"]);
    // https://reactjs.org/docs/hooks-faq.html#is-there-something-like-forceupdate
    const [numRechecks, recheckStateRef] = useReducer(x => x + 1, 0);
    const [, forceUpdate] = useReducer(x => x + 1, 0);
    const updateTabPanel = useCallback(() => forceUpdate(), [forceUpdate]);
    if (mode === 'multipanel' && !tabKey) {
        throw new Error("TabPanel: tabKey prop must be set when mode='multipanel'");
    }
    if (mode === 'singlepanel' && tabKey) {
        console.warn("TabPanel: tabKey prop is not supported for mode='singlepanel'. Did you mean to set mode='multipanel'?");
    }
    // Force update until stateRef.current has been filled
    useEffect(() => {
        if (!(stateRef === null || stateRef === void 0 ? void 0 : stateRef.current)) {
            if (numRechecks > 1000) {
                console.warn('TabPanel stateRef never received a value. Did you forget to pass stateRef to both TabList and TabPanel?');
                return;
            }
            recheckStateRef();
        }
    });
    if (!renderer && !as) {
        as = (_jsx(Div, Object.assign({ ref: ref }, props)));
    }
    if (stateRef.current) {
        stateRef.current.updateTabPanel = updateTabPanel;
        return (_jsx(WrappedTabPanel, Object.assign({ mode: mode, as: as, renderer: renderer, stateRef: stateRef, tabKey: tabKey }, props)));
    }
    if (renderer) {
        return renderer(Object.assign({}, props), null, null);
    }
    return (_jsx(TabPanelClone, Object.assign({ tabRef: mergeRefs(as.ref, ref), cloneAs: as }, { children: props.children })));
});
export default TabPanel;
//# sourceMappingURL=TabPanel.js.map