var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Div } from 'honorable';
import { forwardRef, useRef, useState, } from 'react';
import { flexRender, getCoreRowModel, getExpandedRowModel, useReactTable, } from '@tanstack/react-table';
import styled from 'styled-components';
import Button from './Button';
import CaretUpIcon from './icons/CaretUpIcon';
import { FillLevelProvider } from './contexts/FillLevelContext';
const propTypes = {};
const T = styled.table(({ theme }) => (Object.assign({ backgroundColor: theme.colors['fill-one'], borderSpacing: 0, width: '100%' }, theme.partials.text.body2LooseLineHeight)));
const TheadUnstyled = forwardRef((props, ref) => (_jsx(FillLevelProvider, Object.assign({ value: 2 }, { children: _jsx("thead", Object.assign({}, props, { ref: ref })) }))));
const Thead = styled(TheadUnstyled)(({ theme }) => ({
    backgroundColor: theme.colors['fill-two'],
    position: 'sticky',
    top: 0,
    zIndex: 3,
}));
const TbodyUnstyled = forwardRef((props, ref) => (_jsx(FillLevelProvider, Object.assign({ value: 1 }, { children: _jsx("tbody", Object.assign({ ref: ref }, props)) }))));
const Tbody = styled(TbodyUnstyled)(({ theme }) => ({
    backgroundColor: theme.colors['fill-one'],
}));
const Tr = styled.tr(() => ({
    backgroundColor: 'inherit',
}));
const Th = styled.th(({ theme, stickyColumn }) => ({
    borderBottom: theme.borders['fill-three'],
    color: theme.colors.text,
    height: 48,
    minHeight: 48,
    whiteSpace: 'nowrap',
    padding: '14px 12px',
    textAlign: 'left',
    '&:first-child': stickyColumn
        ? {
            backgroundColor: 'inherit',
            boxShadow: theme.boxShadows.slight,
            position: 'sticky',
            left: 0,
            zIndex: 5,
        }
        : {},
}));
// TODO: Set vertical align to top for tall cells (~3 lines of text or more). See ENG-683.
const Td = styled.td(({ theme, firstRow, lighter, loose, stickyColumn, }) => ({
    backgroundColor: lighter
        ? theme.colors['fill-one']
        : theme.colors['fill-one-hover'],
    borderTop: firstRow ? '' : theme.borders.default,
    color: theme.colors.text,
    height: 52,
    minHeight: 52,
    padding: loose ? '16px 12px' : '8px 12px',
    '&:first-child': stickyColumn
        ? {
            boxShadow: theme.boxShadows.slight,
            position: 'sticky',
            left: 0,
            zIndex: 1,
        }
        : {},
}));
const TdExpand = styled.td(({ theme, lighter }) => ({
    backgroundColor: lighter
        ? theme.colors['fill-one']
        : theme.colors['fill-one-hover'],
    color: theme.colors.text,
    height: 52,
    minHeight: 52,
    padding: '16px 12px',
}));
function TableRef(_a) {
    var { data, columns, getRowCanExpand, renderExpanded, loose = false, stickyColumn = false, scrollTopMargin = 500, width } = _a, props = __rest(_a, ["data", "columns", "getRowCanExpand", "renderExpanded", "loose", "stickyColumn", "scrollTopMargin", "width"]);
    const ref = useRef();
    const [hover, setHover] = useState(false);
    const [scrollTop, setScrollTop] = useState(0);
    const table = useReactTable({
        data,
        columns,
        getRowCanExpand,
        getCoreRowModel: getCoreRowModel(),
        getExpandedRowModel: getExpandedRowModel(),
    });
    return (_jsxs(Div, Object.assign({ position: "relative", width: width, onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false) }, { children: [_jsx(Div, Object.assign({ backgroundColor: "fill-two", border: "1px solid border-fill-two", borderRadius: "large", overflow: "auto", ref: ref, onScroll: ({ target }) => setScrollTop(target === null || target === void 0 ? void 0 : target.scrollTop), width: width }, props, { children: _jsxs(T, { children: [_jsx(Thead, { children: table.getHeaderGroups().map(headerGroup => (_jsx(Tr, { children: headerGroup.headers.map(header => (_jsx(Th, Object.assign({ stickyColumn: stickyColumn }, { children: header.isPlaceholder
                                        ? null
                                        : flexRender(header.column.columnDef.header, header.getContext()) }), header.id))) }, headerGroup.id))) }), _jsx(Tbody, { children: table.getRowModel().rows.map((row, i) => (_jsxs(_Fragment, { children: [_jsx(Tr, { children: row.getVisibleCells().map(cell => (_jsx(Td, Object.assign({ firstRow: i === 0, lighter: i % 2 === 0, loose: loose, stickyColumn: stickyColumn }, { children: flexRender(cell.column.columnDef.cell, cell.getContext()) }), cell.id))) }, row.id), row.getIsExpanded() && (_jsxs(Tr, { children: [_jsx(TdExpand, { lighter: i % 2 === 0 }), _jsx(TdExpand, Object.assign({ colSpan: row.getVisibleCells().length - 1, lighter: i % 2 === 0 }, { children: renderExpanded({ row }) }))] }))] }))) })] }) })), hover && scrollTop > scrollTopMargin && (_jsx(Button, Object.assign({ small: true, position: "absolute", right: "24px", bottom: "24px", width: "140px", floating: true, endIcon: _jsx(CaretUpIcon, {}), onClick: () => {
                    var _a;
                    return (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.scrollTo({
                        top: 0,
                        behavior: 'smooth',
                    });
                } }, { children: "Back to top" })))] })));
}
const Table = forwardRef(TableRef);
Table.propTypes = propTypes;
export default Table;
//# sourceMappingURL=Table.js.map