var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Layer } from 'grommet';
import { forwardRef, useCallback, useEffect, useState, } from 'react';
import Banner from './Banner';
const defaults = {
    closeTimeout: 10000,
    position: 'bottom-right',
    onClose: () => { },
    severity: 'info',
};
const Toast = forwardRef((_a, ref) => {
    var { position = defaults.position, closeTimeout = defaults.closeTimeout, onClose = defaults.onClose, severity = defaults.severity, children } = _a, props = __rest(_a, ["position", "closeTimeout", "onClose", "severity", "children"]);
    const [open, setOpen] = useState(true);
    const close = useCallback(() => {
        setOpen(false);
        onClose();
    }, [setOpen, onClose]);
    useEffect(() => {
        const timer = open ? setTimeout(() => close(), closeTimeout) : null;
        return () => clearTimeout(timer);
    });
    if (!open) {
        return null;
    }
    return (_jsx(Layer, Object.assign({ position: position, plain: true, modal: false, ref: ref }, { children: _jsx(Banner, Object.assign({ onClose: close, severity: severity }, props, { children: children })) })));
});
function GraphQLToast(_a) {
    var _b;
    var { error, header } = _a, props = __rest(_a, ["error", "header"]);
    return (_jsxs(Toast, Object.assign({ severity: "error" }, props, { children: [header, ": ", (_b = error === null || error === void 0 ? void 0 : error.graphQLErrors[0]) === null || _b === void 0 ? void 0 : _b.message] })));
}
export { Toast, GraphQLToast };
//# sourceMappingURL=Toast.js.map