import { ReactNode } from 'react';
import { Placement } from '@floating-ui/react-dom-interactions';
import { DivProps } from 'honorable';
declare type TooltipProps = {
    label: ReactNode;
    placement?: Placement;
    children?: JSX.Element;
    displayOn?: 'hover' | 'click' | 'focus' | 'manual' | 'none';
    arrowProps?: DivProps;
    manualOpen?: boolean;
    strategy?: 'absolute' | 'fixed';
    arrow?: boolean;
    dismissable?: boolean;
    portal?: boolean;
    onOpenChange?: (open: boolean) => unknown;
} & DivProps;
declare function Tooltip({ children, label, placement, displayOn, manualOpen, arrowProps, strategy, arrow: showArrow, dismissable, offset: tipOffset, portal, portalProps, onOpenChange, ...props }: TooltipProps): JSX.Element;
export default Tooltip;
export { TooltipProps };
