import React, { PropsWithChildren, ReactNode } from 'react';
import { InputProps } from 'honorable';
export declare type ValidationResponse = {
    error: boolean;
    message: string;
} | null;
export declare type CaptionProps = {
    caption: string;
    color: string;
};
export declare type ValidatedInputProps = InputProps & PropsWithChildren<{
    label?: ReactNode;
    hint?: ReactNode;
    caption?: (props: CaptionProps) => React.ReactElement;
    validation?: (val: string) => ValidationResponse;
}>;
declare const ValidatedInput: React.ComponentType<Omit<import("honorable").DivProps, "onFocus" | "onBlur" | "onChange" | "onKeyDown" | "onKeyUp"> & import("honorable").InputBaseProps & {
    label?: ReactNode;
    hint?: ReactNode;
    caption?: (props: CaptionProps) => React.ReactElement;
    validation?: (val: string) => ValidationResponse;
} & {
    children?: React.ReactNode;
} & React.RefAttributes<any>>;
export default ValidatedInput;
