var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React, { forwardRef, useCallback, useState, } from 'react';
import PropTypes from 'prop-types';
import { Input, Span } from 'honorable';
import FormField from './FormField';
const propTypes = {
    label: PropTypes.node,
    hint: PropTypes.node,
    caption: PropTypes.func,
    validation: PropTypes.func,
};
function defaultCaption({ caption, color }) {
    return (_jsx(Span, Object.assign({ color: color }, { children: caption })));
}
function ValidatedInputRef(_a, ref) {
    var { label, hint, validation, onChange, width, caption } = _a, input = __rest(_a, ["label", "hint", "validation", "onChange", "width", "caption"]);
    const [error, setError] = useState(null);
    const wrappedOnChange = useCallback((e) => {
        var _a;
        if (onChange)
            onChange(e);
        setError((validation && ((_a = e.target) === null || _a === void 0 ? void 0 : _a.value)) ? validation(e.target.value) : undefined);
    }, [onChange, validation]);
    const captionComp = caption || defaultCaption;
    return (_jsx(FormField, Object.assign({ ref: ref, label: label, hint: hint, caption: error ? React.createElement(captionComp, { caption: error.message, color: error.error ? 'text-danger' : 'text-success' }) : null, width: width }, { children: _jsx(Input, Object.assign({ onChange: wrappedOnChange, width: "100%" }, input, { error: error === null || error === void 0 ? void 0 : error.error, valid: error ? !error.error : null })) })));
}
const ValidatedInput = forwardRef(ValidatedInputRef);
ValidatedInput.propTypes = propTypes;
export default ValidatedInput;
//# sourceMappingURL=ValidatedInput.js.map