import { createContext, useContext } from 'react';
const MIN_FILL = 0;
const MAX_FILL = 3;
export const FillLevelContext = createContext(0);
export const FillLevelProvider = FillLevelContext.Provider;
export const useFillLevel = () => useContext(FillLevelContext);
export function toFillLevel(x) {
    return Math.max(Math.min(Math.floor(x), MAX_FILL), MIN_FILL);
}
export function isFillLevel(x) {
    return Number.isInteger(x) && x <= MAX_FILL && x >= MIN_FILL;
}
//# sourceMappingURL=FillLevelContext.js.map