var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Flex, H3 } from 'honorable';
import { Card, WrapWithIf } from '..';
import AppIcon from '../components/AppIcon';
export default {
    title: 'AppIcon',
    component: AppIcon,
    argTypes: {
        icon: {
            options: [
                '/logos/plural-logomark-only-black.svg',
                '/logos/plural-logomark-only-white.svg',
                '/logos/airflow-logo.svg',
                '/logos/airbyte-logo.svg',
            ],
            control: {
                type: 'select',
                labels: {
                    '/logos/plural-logomark-only-black.svg': 'Plural Black',
                    '/logos/plural-logomark-only-white.svg': 'Plural White',
                    '/logos/airflow-logo.svg': 'Airflow',
                    '/logos/airbyte-logo.svg': 'Airbyte',
                },
            },
        },
        hue: {
            options: [undefined, 'default', 'lighter', 'lightest'],
            control: {
                type: 'select',
            },
        },
        onFillLevel: {
            options: [0, 1, 2, 3],
            control: {
                type: 'select',
                labels: {
                    0: '0',
                    1: '1',
                    2: '2',
                    3: "3 - Shouldn't be used",
                },
            },
        },
    },
};
const sizes = [
    { label: 'Extra Large', size: 'xlarge' },
    { label: 'Large', size: 'large' },
    { label: 'Medium', size: 'medium' },
    { label: 'Small', size: 'small' },
    { label: 'Extra Small', size: 'xsmall' },
];
function Template(_a) {
    var { onFillLevel } = _a, args = __rest(_a, ["onFillLevel"]);
    return (_jsx(Flex, Object.assign({ gap: 16, direction: "column" }, { children: sizes.map(({ label, size }) => (_jsxs(_Fragment, { children: [_jsx(H3, { children: label }), _jsx(WrapWithIf, Object.assign({ condition: onFillLevel > 0, wrapper: (_jsx(Card, { fillLevel: onFillLevel, padding: "small" })) }, { children: _jsxs(Flex, Object.assign({ direction: "row", gap: 16 }, { children: [_jsx(AppIcon, Object.assign({ size: size, url: args.icon }, args)), _jsx(AppIcon, Object.assign({ size: size, url: "photo.png", spacing: "none" }, args)), _jsx(AppIcon, Object.assign({ size: size, name: args.name || undefined, initials: args.name || undefined }, args))] })) }))] }))) })));
}
export const Default = Template.bind({});
Default.args = {
    name: 'Michael J Guarino',
    initials: '',
    icon: '/logos/plural-logomark-only-black.svg',
    onFillLevel: 0,
    hue: undefined,
    clickable: false,
};
//# sourceMappingURL=AppIcon.stories.js.map