import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Flex, H1 } from 'honorable';
import Button from '../components/Button';
import DownloadIcon from '../components/icons/DownloadIcon';
export default {
    title: 'Button',
    component: Button,
    argTypes: {
        padding: {
            options: ['', 'none'],
            control: {
                type: 'select',
                labels: {
                    // Can't have empty string as key for labels
                    // Breaks controls for every other component that appears after this
                    // '': 'Enabled',
                    none: 'Disabled',
                },
            },
        },
    },
};
function TemplateBase(args) {
    return (_jsxs(Flex, Object.assign({ direction: "row", gap: "medium", wrap: "wrap", alignItems: "center" }, { children: [_jsx(Button, Object.assign({ large: true }, args)), _jsx(Button, Object.assign({ large: true, startIcon: _jsx(DownloadIcon, {}), endIcon: _jsx(DownloadIcon, {}) }, args)), _jsx(Button, Object.assign({}, args)), _jsx(Button, Object.assign({ startIcon: _jsx(DownloadIcon, {}), endIcon: _jsx(DownloadIcon, {}) }, args)), _jsx(Button, Object.assign({ small: true }, args)), _jsx(Button, Object.assign({ small: true, startIcon: _jsx(DownloadIcon, {}), endIcon: _jsx(DownloadIcon, {}) }, args))] })));
}
function Template(args) {
    return (_jsxs(_Fragment, { children: [_jsx(H1, Object.assign({ subtitle2: true, marginBottom: "small" }, { children: "Enabled" })), _jsx(TemplateBase, Object.assign({}, args)), _jsx(H1, Object.assign({ subtitle2: true, marginTop: "large", marginBottom: "small" }, { children: "Disabled" })), _jsx(TemplateBase, Object.assign({}, args, { disabled: true }))] }));
}
export const Primary = Template.bind({});
Primary.args = {
    disabled: false,
    loading: false,
    pulse: false,
    children: 'Primary Button',
};
export const Secondary = Template.bind({});
Secondary.args = {
    disabled: false,
    loading: false,
    children: 'Secondary Button',
    secondary: true,
};
export const Tertiary = Template.bind({});
Tertiary.args = {
    disabled: false,
    loading: false,
    children: 'Tertiary Button',
    tertiary: true,
    padding: '',
};
export const Destructive = Template.bind({});
Destructive.args = {
    disabled: false,
    loading: false,
    children: 'Destructive Button',
    destructive: true,
};
export const Floating = Template.bind({});
Floating.args = {
    disabled: false,
    loading: false,
    children: 'Floating Button',
    floating: true,
};
//# sourceMappingURL=Button.stories.js.map