import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Div } from 'honorable';
import { Callout, Card } from '..';
export default {
    title: 'Callout',
    component: Callout,
    argTypes: {
        size: {
            options: ['full', 'compact'],
            control: { type: 'select' },
        },
        onFillLevel: {
            options: [0, 1, 2, 3],
            control: {
                type: 'select',
                labels: {
                    0: '0',
                    1: '1',
                    2: '2',
                    3: "3 - Shouldn't be used",
                },
            },
        },
    },
};
const styles = [
    'info',
    'success',
    'warning',
    'danger',
];
const fullContent = (_jsxs(_Fragment, { children: ["Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor ", _jsx("a", Object.assign({ href: "" }, { children: "incididunt ut labore" })), " et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat."] }));
const compactContent = (_jsxs(_Fragment, { children: ["Lorem ipsum dolor sit amet, consectetur ", _jsx("a", Object.assign({ href: "" }, { children: "adipiscing elit" })), ", sed do."] }));
function Template({ size, withButton, title, fillLevel, onFillLevel, }) {
    let Wrapper = Div;
    let wrapperProps = {};
    if (onFillLevel > 0) {
        Wrapper = Card;
        wrapperProps = Object.assign(Object.assign({}, wrapperProps), {
            fillLevel: onFillLevel,
            padding: 'medium',
        });
    }
    return (_jsx(Wrapper, Object.assign({ display: "flex", flexDirection: "column", gap: "large", maxWidth: 600 }, wrapperProps, { children: styles.map(style => (_jsx(Callout, Object.assign({ severity: style, size: size, title: title, fillLevel: fillLevel, buttonProps: withButton ? { children: 'Button text' } : undefined }, { children: size === 'compact' ? compactContent : fullContent })))) })));
}
export const Default = Template.bind({});
Default.args = {
    title: '',
    size: 'full',
    withButton: false,
    onFillLevel: 0,
};
export const WithTitle = Template.bind({});
WithTitle.args = {
    title: 'Title text - How to write a dummy title',
    size: 'full',
    withButton: false,
    onFillLevel: 0,
};
export const Compact = Template.bind({});
Compact.args = {
    title: '',
    size: 'compact',
    withButton: false,
    onFillLevel: 0,
};
export const WithButton = Template.bind({});
WithButton.args = {
    title: '',
    size: 'full',
    withButton: true,
    onFillLevel: 0,
};
export const KitchenSink = Template.bind({});
KitchenSink.args = {
    title: 'Title text - How to write a dummy title',
    size: 'full',
    withButton: true,
    onFillLevel: 0,
};
export const OnCard = Template.bind({});
OnCard.args = {
    title: 'Title text - How to write a dummy title',
    size: 'full',
    withButton: true,
    onFillLevel: 1,
};
//# sourceMappingURL=Callout.stories.js.map