import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { A, Button, Div, Flex, Span, } from 'honorable';
import { useCallback, useState } from 'react';
import { Checklist } from '../components/Checklist';
import { ChecklistItem } from '../components/ChecklistItem';
import DownloadIcon from '../components/icons/DownloadIcon';
import GitHubLogoIcon from '../components/icons/GitHubLogoIcon';
import MarketIcon from '../components/icons/MarketIcon';
import SourcererIcon from '../components/icons/SourcererIcon';
import TerminalIcon from '../components/icons/TerminalIcon';
export default {
    title: 'Checklist',
    component: Checklist,
};
function Template() {
    const [selected, setSelected] = useState(0);
    const [focused, setFocused] = useState(-1);
    const [completed, setCompleted] = useState(-1);
    const [open, setOpen] = useState(true);
    const [dismiss, setDismiss] = useState(false);
    const checklistStateProps = {
        onSelectionChange: setSelected,
        onFocusChange: setFocused,
        onOpenChange: setOpen,
        selectedKey: selected,
        focusedKey: focused,
        completedKey: completed,
        isOpen: open,
        isDismissed: dismiss,
    };
    const isCompleted = useCallback(() => completed >= selected, [completed, selected]);
    const canComplete = useCallback(() => Math.abs(selected - completed) === 1, [selected, completed]);
    const completeButton = (_jsx(Button, Object.assign({ small: true, onClick: () => {
            setCompleted(selected);
            setSelected(selected + 1);
            setFocused(selected + 1);
        }, disabled: isCompleted() || !canComplete() }, { children: "Mark as done" })));
    return (_jsx(Flex, Object.assign({ grow: 1, justify: "center", style: {
            bottom: 0,
            position: 'fixed',
        } }, { children: _jsxs(Checklist, Object.assign({ label: "Getting Started", stateProps: checklistStateProps, footerChildren: (_jsxs(Flex, Object.assign({ gap: "small" }, { children: [_jsx(Button, Object.assign({ secondary: true, small: true }, { children: "Support" })), _jsx(Button, Object.assign({ secondary: true, small: true }, { children: "Docs" })), _jsx(Button, Object.assign({ secondary: true, small: true }, { children: "GitHub" })), _jsx(Flex, { flex: "1" }), _jsx(Button, Object.assign({ small: true, tertiary: true, padding: "none", onClick: () => setDismiss(true) }, { children: "Dismiss" }))] }))), completeChildren: (_jsxs(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: [_jsxs(Flex, Object.assign({ paddingHorizontal: "large", gap: "medium" }, { children: [_jsx(SourcererIcon, {}), _jsxs(Flex, Object.assign({ gap: "xxsmall", direction: "column" }, { children: [_jsx(Span, Object.assign({ subtitle1: true }, { children: "Congratulations!" })), _jsx(Span, Object.assign({ body2: true }, { children: "You're well on your way to becoming an open-sourcerer." }))] }))] })), _jsx(Div, { height: 1, backgroundColor: "border-input" }), _jsxs(Flex, Object.assign({ gap: "small", paddingHorizontal: "large" }, { children: [_jsx(Button, Object.assign({ small: true, secondary: true, startIcon: _jsx(GitHubLogoIcon, {}) }, { children: "Star us on GitHub" })), _jsx(Flex, { grow: 1 }), _jsx(Button, Object.assign({ small: true, secondary: true, onClick: () => {
                                    setCompleted(-1);
                                    setSelected(0);
                                } }, { children: "Restart" })), _jsx(Button, Object.assign({ small: true, onClick: () => setDismiss(true) }, { children: "Complete" }))] }))] }))) }, { children: [_jsx(ChecklistItem, Object.assign({ title: "Setup on your own cloud" }, { children: _jsxs(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: [_jsxs(Span, { children: ["If you'd prefer to use Plural on your local machine, get started with the ", _jsx(A, Object.assign({ inline: true }, { children: "Plural CLI" })), "."] }), _jsxs(Flex, Object.assign({ gap: "small" }, { children: [_jsx(Button, Object.assign({ small: true, secondary: true, startIcon: _jsx(TerminalIcon, {}), onClick: () => setOpen(false) }, { children: "Launch Cloud Shell" })), completeButton] }))] })) })), _jsx(ChecklistItem, Object.assign({ title: "Install Plural Console" }, { children: _jsxs(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: ["This will enable out-of-the-box monitoring, scaling, and security for all your applications.", _jsxs(Flex, Object.assign({ gap: "small" }, { children: [_jsx(Button, Object.assign({ small: true, secondary: true, startIcon: _jsx(DownloadIcon, {}) }, { children: "Install" })), completeButton] }))] })) })), _jsx(ChecklistItem, Object.assign({ title: "Install another app" }, { children: _jsxs(Flex, Object.assign({ gap: "small" }, { children: [_jsx(Button, Object.assign({ small: true, secondary: true, startIcon: _jsx(MarketIcon, {}) }, { children: "View marketplace" })), completeButton] })) }))] })) })));
}
export const Default = Template.bind({});
Default.args = {};
//# sourceMappingURL=Checklist.stories.js.map