var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Div, Flex, H1 } from 'honorable';
import { StatusOkIcon, WrapWithIf } from '..';
import Chip from '../components/Chip';
import Card from '../components/Card';
export default {
    title: 'Chip',
    component: Chip,
    argTypes: {
        hue: {
            options: [undefined, 'default', 'lighter', 'lightest'],
            control: {
                type: 'select',
            },
        },
        onFillLevel: {
            options: [0, 1, 2, 3],
            control: {
                type: 'select',
                labels: {
                    0: '0',
                    1: '1',
                    2: '2',
                    3: "3 - Shouldn't be used",
                },
            },
        },
    },
};
const sizes = [
    'small',
    'medium',
    'large',
];
const severities = [
    'neutral',
    'info',
    'success',
    'warning',
    'error',
    'critical',
];
const versionsArgs = [{}, { loading: true }, { icon: _jsx(StatusOkIcon, {}) }];
function Template(_a) {
    var { onFillLevel } = _a, args = __rest(_a, ["onFillLevel"]);
    return (_jsxs(_Fragment, { children: [sizes.map(size => (_jsxs("div", { children: [_jsx(H1, Object.assign({ subtitle2: true, marginBottom: "small" }, { children: `${size[0].toUpperCase()}${size.slice(1)}` })), _jsx(Div, Object.assign({ marginBottom: "xlarge" }, { children: _jsx(WrapWithIf, Object.assign({ condition: onFillLevel > 0, wrapper: (_jsx(Card, { fillLevel: onFillLevel, padding: "small" })) }, { children: _jsx(Flex, Object.assign({ direction: "column", gap: "xlarge" }, { children: versionsArgs.map(version => (_jsx(Flex, Object.assign({ align: "center", gap: "medium" }, { children: severities.map(severity => (_jsx(Chip, Object.assign({ severity: severity, size: size }, version, args, { children: `${severity[0].toUpperCase()}${severity.slice(1)}` })))) })))) })) })) }))] }))), _jsx(H1, Object.assign({ subtitle2: true, marginBottom: "small" }, { children: "Wrapping" })), _jsxs(Flex, Object.assign({ gap: "medium" }, { children: [_jsx(Card, Object.assign({ padding: "medium", width: "160px", fillLevel: onFillLevel }, { children: _jsxs(Flex, Object.assign({ gap: "xsmall", wrap: true }, { children: [_jsx(Chip, Object.assign({ severity: "neutral", size: "small" }, args, { children: "Physical" })), _jsx(Chip, Object.assign({ severity: "warning", size: "small" }, args, { children: "Local" })), _jsx(Chip, Object.assign({ severity: "error", size: "small" }, args, { children: "Adjacent Network" })), _jsx(Chip, Object.assign({ severity: "critical", size: "small" }, args, { children: "Network" }))] })) })), _jsx(Card, Object.assign({ width: "400px", padding: "medium", fillLevel: onFillLevel }, { children: _jsxs(Flex, Object.assign({ gap: "xsmall", wrap: true }, { children: [_jsx(Chip, Object.assign({ size: "small" }, args, { children: "dag" })), _jsx(Chip, Object.assign({ size: "small" }, args, { children: "data-pipelines" })), _jsx(Chip, Object.assign({ size: "small" }, args, { children: "data" })), _jsx(Chip, Object.assign({ size: "small" }, args, { children: "11-11-2022" }))] })) })), _jsx(Card, Object.assign({ width: "200px", padding: "medium", fillLevel: onFillLevel }, { children: _jsxs(Flex, Object.assign({ gap: "xsmall", wrap: true }, { children: [_jsx(Chip, Object.assign({ size: "small" }, args, { children: "data pipelines" })), _jsx(Chip, Object.assign({ size: "small" }, args, { children: "data" }))] })) })), _jsx(Card, Object.assign({ width: "120px", padding: "medium", fillLevel: onFillLevel }, { children: _jsxs(Flex, Object.assign({ gap: "xsmall", wrap: true }, { children: [_jsx(Chip, Object.assign({ size: "small" }, args, { children: "data pipelines" })), _jsx(Chip, Object.assign({ size: "small" }, args, { children: "data" }))] })) }))] }))] }));
}
export const Default = Template.bind({});
Default.args = {
    closeButton: false,
    clickable: false,
    onFillLevel: 0,
};
//# sourceMappingURL=Chip.stories.js.map