var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Flex } from 'honorable';
import { useTheme } from 'styled-components';
import { Card, Code, WrapWithIf } from '..';
import { cCode, elixirCode, goCode, jsCode, rustCode, tfCode, } from '../constants';
export default {
    title: 'Code',
    component: Code,
    argTypes: {
        title: {
            control: 'text',
        },
        showLineNumbers: {
            control: {
                type: 'boolean',
            },
        },
        showHeader: {
            options: [undefined, true, false],
            control: {
                type: 'select',
            },
        },
        onFillLevel: {
            options: [0, 1, 2, 3],
            control: {
                type: 'select',
                labels: {
                    0: '0',
                    1: '1',
                    2: "2 - Shouldn't be used",
                    3: "3 - Shouldn't be used",
                },
            },
        },
        height: {
            control: {
                type: 'number',
            },
        },
    },
};
function Template(_a) {
    var { onFillLevel } = _a, args = __rest(_a, ["onFillLevel"]);
    return (_jsx(WrapWithIf, Object.assign({ condition: onFillLevel > 0, wrapper: (_jsx(Card, { fillLevel: onFillLevel, padding: "medium" })) }, { children: _jsxs(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: [_jsx(Code, Object.assign({ language: "javascript", width: "600px" }, args, { children: jsCode })), _jsx(Code, Object.assign({ language: "terraform", width: "600px", height: "200px" }, args, { children: tfCode })), _jsx(Code, Object.assign({ width: "600px", height: "100px" }, args, { children: jsCode })), _jsx(Code, Object.assign({ language: "go", width: "400px" }, args, { children: goCode })), _jsx(Code, Object.assign({ width: "400px", language: "js" }, args, { children: "console.warn('test')" })), _jsx(Code, Object.assign({ width: "400px" }, args, { children: "One line" })), _jsx(Code, Object.assign({ width: "400px", height: "300px" }, args, { children: "One line with `height` specified" })), _jsx(Code, Object.assign({ width: "400px" }, args, { children: 'Two lines\nTwo lines' })), _jsx(Code, Object.assign({ width: "400px" }, args, { children: 'Three lines\nThree lines\nThree lines' })), _jsx(Code, Object.assign({ language: "javascript" }, args, { children: jsCode }))] })) })));
}
const tabs = [
    {
        key: 'go',
        label: 'Go',
        language: 'golang',
        content: goCode,
    },
    {
        key: 'tf',
        label: 'Terraform',
        language: 'terraform',
        content: tfCode,
    },
    {
        key: 'js',
        label: 'Javascript',
        language: 'javascript',
        content: "const oneLine = 'Just one line'",
    },
    {
        key: 'elixir',
        label: 'Elixir',
        language: 'elixir',
        content: elixirCode,
    },
    {
        key: 'c',
        label: 'C',
        language: 'c',
        content: cCode,
    },
    {
        key: 'rust',
        label: 'Rust',
        language: 'rust',
        content: rustCode,
    },
];
function WithTabsTemplate(_a) {
    var { onFillLevel, title } = _a, args = __rest(_a, ["onFillLevel", "title"]);
    const theme = useTheme();
    return (_jsxs(WrapWithIf, Object.assign({ condition: onFillLevel > 0, wrapper: (_jsx(Card, { fillLevel: onFillLevel, padding: "medium" })) }, { children: [' ', _jsxs(Flex, Object.assign({ flexDirection: "column", gap: theme.spacing.xxlarge, width: "100%" }, { children: [_jsx(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: _jsx(Code, Object.assign({ title: title, tabs: tabs.slice(0, 3) }, args)) })), _jsx(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: _jsx(Code, Object.assign({ title: title, tabs: tabs.slice(0, 3) }, args)) })), _jsx(Flex, Object.assign({ direction: "column", gap: "medium" }, { children: _jsx(Code, Object.assign({ title: title, tabs: tabs.slice(0, 6) }, args)) }))] }))] })));
}
export const Default = Template.bind({});
Default.args = {
    title: '',
    showLineNumbers: true,
    showHeader: undefined,
};
export const WithTabs = WithTabsTemplate.bind({});
WithTabs.args = {
    title: 'This is an optional title',
    showLineNumbers: true,
    showHeader: undefined,
    onFillLevel: 0,
    height: 300,
};
//# sourceMappingURL=Code.stories.js.map