var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from 'react';
import { Div, Input } from 'honorable';
import FormField from '../components/FormField';
import MagnifyingGlassIcon from '../components/icons/MagnifyingGlassIcon';
import CaretDownIcon from '../components/icons/CaretDownIcon';
export default {
    title: 'FormField',
    component: FormField,
};
function Template(args) {
    const [value, setValue] = useState('');
    const { valid, disabled, error, large, small, label, caption, maxLength, hint, startIcon, endIcon, multiline, minRows, maxRows } = args, restArgs = __rest(args, ["valid", "disabled", "error", "large", "small", "label", "caption", "maxLength", "hint", "startIcon", "endIcon", "multiline", "minRows", "maxRows"]);
    return (_jsx(FormField, Object.assign({ label: label, caption: caption, hint: hint, error: error, disabled: disabled, maxLength: maxLength, length: value.length, small: small }, restArgs, { children: _jsx(Input, { value: value, onChange: event => setValue(event.target.value.substring(0, maxLength)), valid: valid, error: error, large: large, small: small, disabled: disabled, placeholder: "Placeholder text", startIcon: startIcon, endIcon: endIcon, multiline: multiline, minRows: minRows, maxRows: maxRows }) })));
}
function AllSizesTemplate(args) {
    return (_jsxs(Div, Object.assign({ maxWidth: "400px" }, { children: [_jsx(Template, Object.assign({ large: true }, args)), _jsx(Template, Object.assign({ marginTop: "medium" }, args)), _jsx(Template, Object.assign({ marginTop: "medium", small: true }, args))] })));
}
export const Full = AllSizesTemplate.bind({});
Full.args = {
    label: 'Label',
    caption: 'Action',
    maxLength: 120,
    hint: 'Hint text',
    startIcon: _jsx(MagnifyingGlassIcon, {}),
    endIcon: _jsx(CaretDownIcon, { size: 10, mt: 0.333, mx: "3px" }),
};
export const FullError = AllSizesTemplate.bind({});
FullError.args = Object.assign(Object.assign({}, Full.args), {
    label: 'Password',
    hint: 'Something is wrong',
    error: true,
});
export const FullDisabled = AllSizesTemplate.bind({});
FullDisabled.args = Object.assign(Object.assign({}, Full.args), {
    disabled: true,
});
export const Default = AllSizesTemplate.bind({});
Default.args = {};
export const Label = AllSizesTemplate.bind({});
Label.args = {
    label: 'Email',
};
export const Required = AllSizesTemplate.bind({});
Required.args = {
    label: 'Email',
    required: true,
};
export const Caption = AllSizesTemplate.bind({});
Caption.args = {
    label: 'Password',
};
export const LongCaption = AllSizesTemplate.bind({});
LongCaption.args = {
    label: 'Label',
};
export const HintText = AllSizesTemplate.bind({});
HintText.args = {
    label: 'Label',
    hint: 'Some hint text',
};
export const MaxLength = AllSizesTemplate.bind({});
MaxLength.args = {
    label: 'Label',
    maxLength: 30,
};
export const ArbitraryHintContent = AllSizesTemplate.bind({});
ArbitraryHintContent.args = {
    label: 'Label',
    hint: (_jsx(Div, Object.assign({ backgroundColor: "fill-one", padding: "medium", width: "100%", textAlign: "center", border: "1px solid border", borderRadius: "medium" }, { children: "Put whatever you want in the hint!" }))),
};
export const Multiline = AllSizesTemplate.bind({});
Multiline.args = {
    label: 'Label',
    multiline: true,
    minRows: 3,
    maxLength: 200,
};
//# sourceMappingURL=FormField.stories.js.map