var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled, { useTheme } from 'styled-components';
import { createElement } from 'react';
import * as icons from '../icons';
export default {
    title: 'Icons',
    component: icons.MarketPlusIcon,
    argTypes: {
        color: {
            options: [
                'icon-default',
                'icon-light',
                'icon-xlight',
                'icon-disabled',
                'icon-primary',
                'icon-secondary',
                'icon-info',
                'icon-success',
                'icon-warning',
                'icon-danger',
                'icon-danger-critical',
            ],
            control: {
                type: 'select',
            },
        },
    },
};
const AppIcon = styled.div(({ theme, $backgroundColor = 'transparent' }) => (Object.assign(Object.assign({ margin: theme.spacing.xxxsmall, paddingTop: theme.spacing.medium, paddingBottom: theme.spacing.xsmall, paddingRight: theme.spacing.xsmall, paddingLeft: theme.spacing.xsmall, border: `1px solid ${theme.colors.border}`, borderRadius: theme.borderRadiuses.medium, display: 'flex', flexDirection: 'column', gap: theme.spacing.xsmall, alignItems: 'center', justifyContent: 'flex-start', width: theme.spacing.xxxlarge, hyphens: 'none', wordBreak: 'break-all', fontSize: '0.75rem', minWidth: '8em', textAlign: 'center' }, theme.partials.text.caption), { backgroundColor: $backgroundColor })));
function Template(_a) {
    var { backgroundColor } = _a, args = __rest(_a, ["backgroundColor"]);
    const theme = useTheme();
    const bgColor = (typeof theme.colors[backgroundColor] === 'string'
        && theme.colors[backgroundColor])
        || backgroundColor;
    return (_jsx("div", Object.assign({ style: {
            display: 'flex',
            flexWrap: 'wrap',
            maxWidth: '100%',
        } }, { children: Object.entries(icons).map(([name, icon]) => (_jsxs(AppIcon, Object.assign({ "$backgroundColor": bgColor }, { children: [_jsx("div", Object.assign({ style: { justifySelf: 'flex-end' } }, { children: createElement(icon, Object.assign({}, args)) })), _jsx("span", { dangerouslySetInnerHTML: {
                        __html: name
                            .replace('Icon', '')
                            .replaceAll(/([a-z])([A-Z])/g, '$1&shy;$2'),
                    } })] }), name))) })));
}
export const Default = Template.bind({});
Default.args = {
    color: 'icon-default',
    size: 16,
    fullColor: false,
    backgroundColor: 'transparent',
};
export const Xlarge = Template.bind({});
Xlarge.args = {
    color: 'icon-default',
    size: 32,
    fullColor: false,
    backgroundColor: 'transparent',
};
export const Large = Template.bind({});
Large.args = {
    color: 'icon-default',
    size: 24,
    fullColor: false,
    backgroundColor: 'transparent',
};
export const Small = Template.bind({});
Small.args = {
    color: 'icon-default',
    size: 12,
    fullColor: false,
    backgroundColor: 'transparent',
};
export const Color = Template.bind({});
Color.args = {
    color: 'icon-primary',
    fullColor: false,
    size: 16,
    backgroundColor: 'transparent',
};
export const FullColor = Template.bind({});
FullColor.args = {
    color: 'icon-default',
    fullColor: true,
    size: 32,
    backgroundColor: 'transparent',
};
//# sourceMappingURL=Icons.stories.js.map