import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Div, Flex } from 'honorable';
import { useState } from 'react';
import { AppIcon, Chip, ListBox, ListBoxFooter, ListBoxFooterPlus, ListBoxItem, ListBoxItemChipList, PersonIcon, } from '../index';
export default {
    title: 'List Box',
    component: ListBox,
};
const portrait = (_jsx(AppIcon, { spacing: "none", size: "xsmall", url: "photo.png" }));
const smallIcon = _jsx(PersonIcon, { size: 16 });
const chipProps = {
    size: 'small',
};
const chips = [
    _jsx(Chip, Object.assign({ severity: "success" }, chipProps, { children: "Installed" })),
    _jsx(Chip, Object.assign({ severity: "neutral" }, chipProps, { children: "Warm" })),
    _jsx(Chip, Object.assign({ severity: "neutral" }, chipProps, { children: "Latest" })),
    _jsx(Chip, Object.assign({ severity: "warning" }, chipProps, { children: "Additional" })),
    _jsx(Chip, Object.assign({ severity: "error" }, chipProps, { children: "Extra" })),
    _jsx(Chip, Object.assign({ severity: "info" }, chipProps, { children: "Another" })),
];
const items = [
    {
        key: 'ratatouille',
        label: 'Ratatouille',
        description: 'With ham and cheese',
        chips: chips.slice(0, 1),
        version: '0.2.24',
    },
    {
        key: 'pizza',
        label: 'Pizza',
        description: 'With ham and cheese',
        chips: chips.slice(1, 3),
        version: '0.2.25',
    },
    {
        key: 'sushi',
        label: 'Sushi',
        description: 'With ham and cheese',
        chips: null,
        version: '0.2.26',
    },
    {
        key: 'couscous',
        label: 'Couscous',
        description: 'With ham and cheese',
        chips: chips.slice(4),
        version: '0.3.00',
    },
    {
        key: 'dim-sum',
        label: 'Dim Sum',
        description: 'With ham and cheese',
        chips: chips.slice(4, 5),
        version: '0.3.01',
    },
    {
        key: 'ratatouille2',
        label: 'Ratatouille',
        description: 'With ham and cheese',
        chips: [chips[0], chips[3], chips[5]],
        version: '0.3.02',
    },
    {
        key: 'pizza2',
        label: 'Pizza',
        description: 'With ham and cheese',
        chips: [chips[5], chips[0]],
        version: '0.3.05',
    },
    {
        key: 'sushi2',
        label: 'Sushi',
        description: 'With ham and cheese',
        chips: chips.slice(0),
        version: '0.3.12',
    },
    {
        key: 'couscous2',
        label: 'Couscous',
        description: 'With ham and cheese',
        chips: chips.slice(0).reverse(),
        version: '0.4.00',
    },
    {
        key: 'dim-sum2',
        label: 'Dim Sum',
        description: 'With ham and cheese',
        chips: chips.slice(5).reverse(),
        version: '0.4.01',
    },
];
function Template() {
    const [selectedKey, setSelectedKey] = useState();
    const shownStep = 4;
    const [shownLimit, setShownLimit] = useState(shownStep);
    return (_jsxs(Flex, Object.assign({ flexDirection: "column", gap: "large" }, { children: [_jsx(Div, Object.assign({ maxWidth: 512 }, { children: _jsx(ListBox, Object.assign({ selectedKey: selectedKey, onSelectionChange: key => {
                        setSelectedKey(key);
                    }, extendStyle: {
                        width: 'max-content',
                    } }, { children: items.slice(0, 4).map(({ key, label }) => (_jsx(ListBoxItem, { label: label, leftContent: smallIcon, reserveSelectedIndicatorSpace: true }, key))) })) })), _jsx(Div, Object.assign({ display: "flex", flexDirection: "column", maxWidth: 512, maxHeight: 200, overflow: "hidden" }, { children: _jsx(ListBox, Object.assign({ selectedKey: selectedKey, onSelectionChange: key => {
                        setSelectedKey(key);
                    }, footerFixed: (_jsx(ListBoxFooter, Object.assign({ onClick: () => alert('You clicked the footer') }, { children: "Fixed Footer - Default" }))) }, { children: items.map(({ key, label, description }) => (_jsx(ListBoxItem, { label: label, description: description, leftContent: portrait }, key))) })) })), _jsx(Div, Object.assign({ display: "flex", flexDirection: "column", maxWidth: 512, maxHeight: 200, overflow: "hidden" }, { children: _jsx(ListBox, Object.assign({ selectedKey: selectedKey, onSelectionChange: key => {
                        setSelectedKey(key);
                    }, footerFixed: (_jsx(ListBoxFooterPlus, Object.assign({ onClick: () => alert('You clicked the footer') }, { children: "Fixed Footer - Add" }))) }, { children: items.map(({ key, label, description, chips, }) => (_jsx(ListBoxItem, { label: label, description: description, rightContent: _jsx(ListBoxItemChipList, { chips: chips }), leftContent: portrait }, key))) })) })), _jsx(Div, Object.assign({ display: "flex", flexDirection: "column", maxWidth: 224, maxHeight: 200, overflow: "hidden" }, { children: _jsx(ListBox, Object.assign({ selectedKey: selectedKey, onSelectionChange: key => {
                        setSelectedKey(key);
                    }, footer: shownLimit < items.length && (_jsx(ListBoxFooterPlus, { children: "View more" })), onFooterClick: () => {
                        setShownLimit(shownLimit + shownStep);
                    } }, { children: items.slice(0, shownLimit).map(({ key, chips, version }) => (_jsx(ListBoxItem, { label: version, rightContent: (_jsx(ListBoxItemChipList, { maxVisible: 2, showExtra: true, chips: chips })) }, key))) })) })), _jsx(Div, Object.assign({ display: "flex", flexDirection: "column", maxWidth: 224, maxHeight: 200, overflow: "hidden" }, { children: _jsxs(ListBox, Object.assign({ extendStyle: { width: 'max-content' }, selectedKey: null, onSelectionChange: key => {
                        setSelectedKey(key);
                    } }, { children: [_jsx(ListBoxItem, { label: "Add user", textValue: "Add user" }, "add-user"), _jsx(ListBoxItem, { label: "Modify user", textValue: "Modify user" }, "modify-user"), _jsx(ListBoxItem, { label: "Delete user", destructive: true }, "delete-user")] })) }))] })));
}
export const Default = Template.bind({});
Default.args = {};
//# sourceMappingURL=ListBox.stories.js.map