import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Button, Div } from 'honorable';
import { useState } from 'react';
import styled, { useTheme } from 'styled-components';
import Radio from '../components/Radio';
import RadioGroup from '../components/RadioGroup';
export default {
    title: 'Radio',
    component: Radio,
};
const radios = [
    {
        value: '0',
        label: 'Implement design system',
    },
    {
        value: '1',
        label: 'Fix a bug',
    },
    {
        value: '2',
        label: 'Take a break',
    },
];
const H1 = styled.h1(({ theme }) => (Object.assign(Object.assign({}, theme.partials.text.subtitle1), { '&:not(:first-child)': {
        marginTop: theme.spacing.xxlarge,
    } })));
function Template(args) {
    const [selectedValueRG, setSelectedValueRG] = useState(undefined);
    const [selectedValueManual, setSelectedValueManual] = useState(undefined);
    const theme = useTheme();
    return (_jsxs(_Fragment, { children: [_jsx(H1, { children: "Controlled by RadioGroup" }), _jsx(RadioGroup, Object.assign({ name: "radio-group-controlled", value: selectedValueRG, onChange: setSelectedValueRG }, { children: radios.map(({ value, label }) => (_jsx(Radio, Object.assign({ value: value }, args, { children: label })))) })), _jsx(Button, Object.assign({ marginTop: theme.spacing.medium, onClick: () => {
                    setSelectedValueRG(null);
                } }, { children: "Reset" })), _jsx(H1, { children: "Manually Controlled" }), _jsx(Div, { children: radios.map(({ value, label }) => (_jsx(Radio, Object.assign({ name: "manually-controlled", value: value, checked: selectedValueManual === value, onChange: ({ target: { checked } }) => {
                        if (checked)
                            setSelectedValueManual(value);
                    } }, args, { children: label })))) }), _jsx(Button, Object.assign({ marginTop: theme.spacing.medium, onClick: () => {
                    setSelectedValueManual(null);
                } }, { children: "Reset" }))] }));
}
export const Default = Template.bind({});
Default.args = {
    small: false,
};
export const Small = Template.bind({});
Small.args = {
    small: true,
};
//# sourceMappingURL=Radio.stories.js.map