var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Button, Div, Flex, H1, } from 'honorable';
import { forwardRef, useRef, useState, } from 'react';
import styled, { useTheme } from 'styled-components';
import { Tab, TabList, TabPanel, } from '../index';
export default {
    title: 'Tab List',
    component: TabList,
};
const tabs = {
    lions: {
        label: 'Lions',
        content: "The lion (Panthera leo) is a large cat of the genus Panthera native to Africa and India. It has a muscular, broad-chested body, short, rounded head, round ears, and a hairy tuft at the end of its tail. It is sexually dimorphic; adult male lions are larger than females and have a prominent mane. It is a social species, forming groups called prides. A lion's pride consists of a few adult males, related females, and cubs. Groups of female lions usually hunt together, preying mostly on large ungulates. The lion is an apex and keystone predator; although some lions scavenge when opportunities occur and have been known to hunt humans, the species typically does not actively seek out and prey on humans.",
    },
    tigers: {
        label: 'Tigers',
        content: "The tiger (Panthera tigris) is the largest living cat species and a member of the genus Panthera. It is most recognisable for its dark vertical stripes on orange fur with a white underside. An apex predator, it primarily preys on ungulates such as deer and wild boar. It is territorial and generally a solitary but social predator, requiring large contiguous areas of habitat, which support its requirements for prey and rearing of its offspring. Tiger cubs stay with their mother for about two years, then become independent and leave their mother's home range to establish their own.",
    },
    bears: {
        label: 'Bears',
        content: 'Bears are carnivoran mammals of the family Ursidae. They are classified as caniforms, or doglike carnivorans. Although only eight species of bears are extant, they are widespread, appearing in a wide variety of habitats throughout the Northern Hemisphere and partially in the Southern Hemisphere. Bears are found on the continents of North America, South America, Europe, and Asia. Common characteristics of modern bears include large bodies with stocky legs, long snouts, small rounded ears, shaggy hair, plantigrade paws with five nonretractile claws, and short tails.',
    },
    ohmy: {
        label: 'Oh my!',
        content: 'George Takei (Japanese: ジョージ・タケイ, born Hosato Takei (武井 穂郷); April 20, 1937) is an American actor, author, and activist. He is internationally known for his role as Hikaru Sulu, helmsman of the fictional starship USS Enterprise in the television series Star Trek and subsequent films.[1][2]',
    },
};
function TemplateBasic(args) {
    var _a, _b;
    const tabStateRef = useRef();
    const [selectedKey, setSelectedKey] = useState('lions');
    const orientation = args.orientation || 'horizontal';
    const tabListStateProps = {
        keyboardActivation: 'manual',
        orientation,
        selectedKey,
        onSelectionChange: setSelectedKey,
    };
    return (_jsx(Div, { children: _jsxs(Flex, Object.assign({ flexDirection: orientation === 'vertical' ? 'row' : 'column', maxWidth: 800 }, { children: [_jsx(TabList, Object.assign({ stateRef: tabStateRef, stateProps: tabListStateProps, flexShrink: 0, marginRight: orientation === 'vertical' ? 'large' : 0, marginBottom: orientation === 'vertical' ? 0 : 'xlarge', width: orientation === 'vertical' ? '100px' : '100%' }, { children: Object.entries(tabs).map(([key, tab]) => (_jsx(Tab, Object.assign({ textValue: tab.label }, { children: tab.label }), key))) })), _jsxs(Div, { children: [_jsx(H1, Object.assign({ title1: true, marginBottom: "medium" }, { children: (_a = tabs[selectedKey]) === null || _a === void 0 ? void 0 : _a.label })), _jsx(TabPanel, Object.assign({ stateRef: tabStateRef, paddingTop: "large", paddingBottom: "large", borderTop: "1px solid border", borderBottom: "1px solid border" }, { children: (_b = tabs[selectedKey]) === null || _b === void 0 ? void 0 : _b.content }))] })] })) }));
}
const CustomLinkWrappedTab = styled(forwardRef((_a, ref) => {
    var { vertical, active, children, textValue: _textValue, renderer: _renderer } = _a, props = __rest(_a, ["vertical", "active", "children", "textValue", "renderer"]);
    const theme = useTheme();
    return (_jsx("a", Object.assign({ ref: ref, target: "_blank", rel: "noreferrer" }, props, { children: _jsx(Tab, Object.assign({ vertical: vertical, active: active, color: active ? theme.colors['text-success'] : 'red' }, { children: children })) })));
}))(({ active, theme }) => ({
    display: 'block',
    backgroundColor: active
        ? theme.colors['fill-one']
        : theme.colors['fill-zero'],
    textDecoration: 'none',
}));
const MyCustomTab2 = forwardRef((_a, ref) => {
    var { selectedKey } = _a, props = __rest(_a, ["selectedKey"]);
    return (_jsx(Flex, Object.assign({ justifyContent: "center", alignItems: "center" }, props, { ref: ref, width: "100%", padding: "20px", textAlign: "center", border: "1px solid border-fill-two" }, { children: _jsx(Div, Object.assign({ subtitle2: true, padding: "small", background: selectedKey === 'bears'
                ? 'action-primary'
                : selectedKey === 'tigers'
                    ? 'icon-danger'
                    : 'fill-two' }, { children: "Com\u00ADplete\u00ADly custom bears" })) })));
});
function TemplateComplex() {
    var _a, _b;
    const tabStateRef = useRef();
    const [selectedKey, setSelectedKey] = useState('lions');
    const orientation = 'vertical';
    const tabListStateProps = {
        keyboardActivation: 'manual',
        orientation,
        selectedKey,
        onSelectionChange: setSelectedKey,
    };
    return (_jsx(Div, { children: _jsxs(Flex, Object.assign({ flexDirection: orientation === 'vertical' ? 'row' : 'column' }, { children: [_jsxs(TabList, Object.assign({ stateRef: tabStateRef, stateProps: tabListStateProps, as: (_jsx(Div, { flexShrink: 0, marginRight: orientation === 'vertical' ? 'large' : 0, marginBottom: orientation === 'vertical' ? 0 : 'xlarge', width: orientation === 'vertical' ? '200px' : '100%', padding: "10px", border: "1px solid", borderColor: selectedKey === 'lions'
                            ? 'border.primary'
                            : selectedKey === 'tigers'
                                ? 'border-warning'
                                : selectedKey === 'bears'
                                    ? 'border-success'
                                    : 'border-danger' })) }, { children: [_jsx(CustomLinkWrappedTab, Object.assign({ textValue: "Lions" }, { children: '<a>Lions</a>' }), "lions"), _jsx(Tab, Object.assign({ textValue: "Tigers", renderer: (_a, ref) => {
                                var { children } = _a, props = __rest(_a, ["children"]);
                                return (_jsx(Div, Object.assign({}, props, { ref: ref, width: "100%", border: "2px solid border-danger" }, { children: children })));
                            } }, { children: "Wrapped tigers" }), "tigers"), _jsx(MyCustomTab2, { textValue: "something", selectedKey: selectedKey }, "bears"), _jsx(CustomLinkWrappedTab, Object.assign({ textValue: "Oh my!" }, { children: '<a>Oh my!</a>' }), "ohmy")] })), _jsxs(Div, { children: [_jsx(H1, Object.assign({ title1: true, marginBottom: "medium" }, { children: (_a = tabs[selectedKey]) === null || _a === void 0 ? void 0 : _a.label })), _jsx(TabPanel, Object.assign({ stateRef: tabStateRef, paddingTop: "large", paddingBottom: "large", borderTop: "1px solid border", borderBottom: "1px solid border", as: _jsx(Button, {}) }, { children: (_b = tabs[selectedKey]) === null || _b === void 0 ? void 0 : _b.content }))] })] })) }));
}
export const Default = TemplateBasic.bind({});
Default.args = {};
export const Vertical = TemplateBasic.bind({});
Vertical.args = {
    orientation: 'vertical',
};
export const AdvancedContent = TemplateComplex.bind({});
AdvancedContent.args = {};
//# sourceMappingURL=TabList.stories.js.map