import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { createColumnHelper } from '@tanstack/react-table';
import { Flex, P } from 'honorable';
import { AppIcon, ArrowRightLeftIcon, CollapseIcon, IconFrame, InfoIcon, LogsIcon, Table, } from '..';
function StringLabel() {
    return (_jsxs(Flex, Object.assign({ gap: "xsmall", justifyContent: "space-between", alignItems: "center" }, { children: ["String", _jsx(AppIcon, { name: "String", icon: _jsx(LogsIcon, {}), size: "xxsmall" })] })));
}
function BoolLabel() {
    return (_jsxs(Flex, Object.assign({ gap: "xsmall", justifyContent: "space-between", alignItems: "center" }, { children: ["Boolean", _jsx(AppIcon, { name: "Boolean", icon: _jsx(ArrowRightLeftIcon, {}), size: "xxsmall" })] })));
}
const data = [
    {
        function: 'fileExists',
        inputType: 'Path (string)',
        returnedValue: _jsx(BoolLabel, {}),
        description: 'Joins parts of a path',
    },
    {
        function: 'pathJoin',
        inputType: 'Object (interface{}), Path (string), Value (interface{})',
        returnedValue: _jsx(StringLabel, {}),
        description: 'Allows for getting values from other applications...',
        expandable: true,
    },
    {
        function: 'repoRoot',
        inputType: 'fileExists',
        returnedValue: _jsx(StringLabel, {}),
        description: 'Allows for getting values from other applications stored in the contex file. For   example, to use the hostname configured for Grafana in another application {{ .Configuration.grafana.hostname }} can be used.',
        expandable: true,
    },
    {
        function: 'repoName',
        inputType: 'Object (interface{}), Path (string), Value (interface{})',
        returnedValue: _jsx(StringLabel, {}),
        description: 'Allows for getting values from other applications...',
        expandable: true,
    },
];
const columnHelper = createColumnHelper();
const columns = [
    columnHelper.accessor(row => row.function, {
        id: 'function',
        cell: (info) => info.getValue(),
        header: () => _jsx("span", { children: "Function" }),
    }),
    columnHelper.accessor(row => row.inputType, {
        id: 'inputType',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => _jsx("span", { children: "Input (type)" }),
    }),
    columnHelper.accessor(row => row.returnedValue, {
        id: 'returnedValue',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => _jsx("span", { children: "Returned value" }),
    }),
    columnHelper.accessor(row => row.description, {
        id: 'description',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => (_jsxs(Flex, Object.assign({ gap: "xsmall", alignItems: "center", justifyContent: "space-between" }, { children: ["Description", ' ', _jsx(IconFrame, { clickable: true, textValue: "Book", icon: _jsx(InfoIcon, {}), size: "small" })] }))),
    }),
];
const expandingColumns = [
    {
        id: 'expander',
        header: () => { },
        cell: ({ row }) => row.getCanExpand() && (_jsx(CollapseIcon, { size: 8, cursor: "pointer", style: row.getIsExpanded()
                ? {
                    transform: 'rotate(270deg)',
                    transitionDuration: '.2s',
                    transitionProperty: 'transform',
                }
                : {
                    transform: 'rotate(180deg)',
                    transitionDuration: '.2s',
                    transitionProperty: 'transform',
                }, onClick: row.getToggleExpandedHandler() })),
    },
    columnHelper.accessor(row => row.function, {
        id: 'function',
        cell: (info) => info.getValue(),
        header: () => _jsx("span", { children: "Function" }),
    }),
    columnHelper.accessor(row => row.inputType, {
        id: 'inputType',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => _jsx("span", { children: "Input (type)" }),
    }),
    columnHelper.accessor(row => row.returnedValue, {
        id: 'returnedValue',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => _jsx("span", { children: "Returned value" }),
    }),
    columnHelper.accessor(row => row.description, {
        id: 'description',
        cell: (info) => _jsx("span", { children: info.getValue() }),
        header: () => _jsx("span", { children: "Description" }),
    }),
];
export default {
    title: 'Table',
    component: Table,
};
function Template(args) {
    return _jsx(Table, Object.assign({}, args));
}
export const Default = Template.bind({});
Default.args = {
    width: '900px',
    height: '400px',
    data: Array(25).fill(data).flat(),
    columns,
};
export const Loose = Template.bind({});
Loose.args = {
    width: '900px',
    height: '400px',
    data: Array(25).fill(data).flat(),
    columns,
    loose: true,
};
export const StickyColumn = Template.bind({});
StickyColumn.args = {
    width: '400px',
    height: '400px',
    data: Array(25).fill(data).flat(),
    columns,
    stickyColumn: true,
};
export const Expandable = Template.bind({});
Expandable.args = {
    width: '900px',
    height: '400px',
    data: Array(25).fill(data).flat(),
    columns: expandingColumns,
    getRowCanExpand: (row) => row.original.expandable,
    renderExpanded: ({ row }) => (_jsx(P, { children: row.original.description })),
};
//# sourceMappingURL=Table.stories.js.map