import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Button, Flex } from 'honorable';
import { useState } from 'react';
import { GraphQLToast, Toast } from '../components/Toast';
export default {
    title: 'Toast',
    component: Toast,
    argTypes: {
        severity: {
            options: ['info', 'success', 'error'],
            control: { type: 'radio' },
        },
    },
};
function Template(args) {
    const [visible, setVisible] = useState(false);
    const [position, setPosition] = useState('');
    const handleClick = (visible, position) => {
        setVisible(visible);
        setPosition(position);
    };
    return (_jsxs(Flex, Object.assign({ gap: "medium", direction: "column" }, { children: [_jsxs(Flex, Object.assign({ gap: "medium", alignItems: "center", justify: "center" }, { children: [_jsx(Button, Object.assign({ onClick: () => handleClick(true, 'top-left') }, { children: "Top Left" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'top') }, { children: "Top" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'top-right') }, { children: "Top Right" }))] })), _jsxs(Flex, Object.assign({ gap: "medium", alignItems: "center", justify: "center" }, { children: [_jsx(Button, Object.assign({ onClick: () => handleClick(true, 'left') }, { children: "Left" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'center') }, { children: "Center" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'right') }, { children: "Right" }))] })), _jsxs(Flex, Object.assign({ gap: "medium", alignItems: "center", justify: "center" }, { children: [_jsx(Button, Object.assign({ onClick: () => handleClick(true, 'bottom-left') }, { children: "Bottom Left" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'bottom') }, { children: "Bottom" })), _jsx(Button, Object.assign({ onClick: () => handleClick(true, 'bottom-right') }, { children: "Bottom Right" }))] })), visible
                && (_jsx(Toast, Object.assign({ position: position, onClose: () => setVisible(false), margin: "large", severity: args.severity }, { children: "Hello" })))] })));
}
function GraphQLTemplate() {
    const [visible, setVisible] = useState(false);
    const handleClick = (visible) => {
        setVisible(visible);
    };
    return (_jsxs(Flex, { children: [_jsx(Button, Object.assign({ onClick: () => handleClick(true) }, { children: "Show" })), visible
                && (_jsx(GraphQLToast, { margin: "large", onClose: () => setVisible(false), error: {
                        graphQLErrors: [{
                                message: 'XYZ could not be found',
                            }],
                    }, header: "404 Not Found" }))] }));
}
export const Default = Template.bind({});
Default.args = {
    severity: 'success',
};
export const GraphQL = GraphQLTemplate.bind({});
GraphQL.args = {};
//# sourceMappingURL=Toast.stories.js.map