export declare type StringObj = {
    [key: string]: string | StringObj;
};
declare const honorableTheme: import("honorable").HonorableTheme;
export default honorableTheme;
export declare const styledTheme: {
    spacing: {
        'minus-xxxxxlarge': number;
        'minus-xxxxlarge': number;
        'minus-xxxlarge': number;
        'minus-xxlarge': number;
        'minus-xlarge': number;
        'minus-large': number;
        'minus-medium': number;
        'minus-small': number;
        'minus-xsmall': number;
        'minus-xxsmall': number;
        'minus-xxxsmall': number;
        none: number;
        xxxsmall: number;
        xxsmall: number;
        xsmall: number;
        small: number;
        medium: number;
        large: number;
        xlarge: number;
        xxlarge: number;
        xxxlarge: number;
        xxxxlarge: number;
        xxxxxlarge: number;
    };
    boxShadows: {
        slight: string;
        moderate: string;
        modal: string;
        focused: string;
    };
    borderRadiuses: {
        medium: number;
        large: number;
        normal: number;
    };
    fontFamilies: {
        mono: string;
        semi: string;
        sans: string;
        sansHero: string;
    };
    borders: {
        default: string;
        'fill-one': string;
        'fill-two': string;
        'fill-three': string;
        input: string;
        'outline-focused': string;
    };
    borderStyles: {
        default: string;
    };
    borderWidths: {
        default: number;
        focus: number;
    };
    zIndexes: {
        base: number;
        selectPopover: number;
        modal: number;
        tooltip: number;
    };
    portals: {
        default: {
            id: string;
        };
    };
    gradients: {
        marketing: {
            bluePurpleTeal: string;
            blueTeal: string;
            purpleTeal: string;
        };
    };
    partials: {
        text: {
            h1: import("styled-components").CSSObject;
            h2: import("styled-components").CSSObject;
            h3: import("styled-components").CSSObject;
            h4: import("styled-components").CSSObject;
            title1: import("styled-components").CSSObject;
            title2: import("styled-components").CSSObject;
            subtitle1: import("styled-components").CSSObject;
            subtitle2: import("styled-components").CSSObject;
            body1: import("styled-components").CSSObject;
            body2: import("styled-components").CSSObject;
            bodyBold: import("styled-components").CSSObject;
            caption: import("styled-components").CSSObject;
            badgeLabel: import("styled-components").CSSObject;
            buttonMedium: import("styled-components").CSSObject;
            buttonLarge: import("styled-components").CSSObject;
            buttonSmall: import("styled-components").CSSObject;
            overline: import("styled-components").CSSObject;
            truncate: import("styled-components").CSSObject;
            inlineLink: import("styled-components").CSSObject;
            code: import("styled-components").CSSObject;
            inlineCode: import("styled-components").CSSObject;
            body1Bold: import("styled-components").CSSObject;
            body2Bold: import("styled-components").CSSObject;
            body2LooseLineHeight: import("styled-components").CSSObject;
            body2LooseLineHeightBold: import("styled-components").CSSObject;
        };
        marketingText: {
            bigHeader: import("styled-components").CSSObject;
            hero1: import("styled-components").CSSObject;
            hero2: import("styled-components").CSSObject;
            title1: import("styled-components").CSSObject;
            title2: import("styled-components").CSSObject;
            subtitle1: import("styled-components").CSSObject;
            subtitle2: import("styled-components").CSSObject;
            body1: import("styled-components").CSSObject;
            body2: import("styled-components").CSSObject;
            inlineLink: import("styled-components").CSSObject;
            navLink: import("styled-components").CSSObject;
            standaloneLink: import("styled-components").CSSObject;
            componentText: import("styled-components").CSSObject;
            componentLink: import("styled-components").CSSObject;
            componentLinkSmall: import("styled-components").CSSObject;
            label: import("styled-components").CSSObject;
            bodyBold: import("styled-components").CSSObject;
            body1Bold: import("styled-components").CSSObject;
            body2Bold: import("styled-components").CSSObject;
        };
        focus: {
            default: import("styled-components").CSSObject;
            outline: import("styled-components").CSSObject;
            button: import("styled-components").CSSObject;
            insetAbsolute: import("styled-components").CSSObject;
        };
        scrollBar: ({ fillLevel }: {
            fillLevel: import("./components/contexts/FillLevelContext").FillLevel;
        }) => StringObj;
        reset: {
            button: import("styled-components").CSSObject;
        };
        dropdown: {
            arrowTransition: ({ isOpen }: {
                isOpen?: boolean;
            }) => {
                transition: string;
                transform: string;
            };
        };
    };
    name: string;
    mode: string;
    breakpoints: {
        desktop: number;
        desktopLarge: number;
    };
    colors: {
        'fill-zero': "#171A21";
        'fill-zero-hover': "#1B1F27";
        'fill-zero-selected': "#252932";
        'fill-one': "#21242C";
        'fill-one-hover': "#252932";
        'fill-one-selected': "#303540";
        'fill-two': "#2A2E37";
        'fill-two-hover': "#303540";
        'fill-two-selected': "#3D424D";
        'fill-three': "#383D47";
        'fill-three-hover': "#3D424D";
        'fill-three-selected': "#4C505C";
        'fill-primary': "#4A51F2";
        'fill-primary-hover': "#5D63F4";
        'action-primary': "#4A51F2";
        'action-primary-hover': "#5D63F4";
        'action-primary-disabled': "#252932";
        'action-link-inactive': "#C5C9D3";
        'action-link-active': "#EBEFF0";
        'action-link-inline': "#99DAFF";
        'action-link-inline-hover': "#C2E9FF";
        'action-link-inline-visited': "#747AF6";
        'action-link-inline-visited-hover': "#9FA3F9";
        'action-input-hover': string;
        border: "#2A2E37";
        'border-input': "#454954";
        'border-fill-two': "#383D47";
        'border-fill-three': "#454954";
        'border-disabled': "#454954";
        'border-outline-focused': "#66C7FF";
        'border-primary': "#747AF6";
        'border-secondary': "#33B4FF";
        'border-success': "#6AF1C2";
        'border-warning': "#FFF59E";
        'border-danger': "#F2788D";
        'border-selected': "#DFE2E7";
        'border-info': "#66C7FF";
        text: "#EBEFF0";
        'text-light': "#C5C9D3";
        'text-xlight': "#A1A5B0";
        'text-long-form': "#B2B7C3";
        'text-disabled': "#454954";
        'text-input-disabled': "#454954";
        'text-primary-accent': "#99DAFF";
        'text-primary-disabled': "#747B8B";
        'text-success': "#17E8A0";
        'text-success-light': "#99F5D5";
        'text-warning': "#FFEB33";
        'text-warning-light': "#FFF9C2";
        'text-danger': "#E95374";
        'text-danger-light': "#F599A8";
        'icon-default': "#DFE2E7";
        'icon-light': "#C5C9D3";
        'icon-xlight': "#A1A5B0";
        'icon-disabled': "#454954";
        'icon-primary': "#747AF6";
        'icon-secondary': "#33B4FF";
        'icon-info': "#99DAFF";
        'icon-success': "#99F5D5";
        'icon-warning': "#FFF9C2";
        'icon-danger': "#F599A8";
        'icon-danger-critical': "#E95374";
        'border-error': "#F2788D";
        'text-error': "#E95374";
        'text-error-light': "#F599A8";
        'icon-error': "#F599A8";
        'marketing-white': "#FFFFFF";
        'marketing-black': "#000000";
        blue: {
            readonly 950: "#001019";
            readonly 900: "#002033";
            readonly 850: "#00304D";
            readonly 800: "#004166";
            readonly 700: "#006199";
            readonly 600: "#0081CC";
            readonly 500: "#06A0F9";
            readonly 400: "#33B4FF";
            readonly 350: "#4DBEFF";
            readonly 300: "#66C7FF";
            readonly 200: "#99DAFF";
            readonly 100: "#C2E9FF";
            readonly 50: "#F0F9FF";
        };
        grey: {
            readonly 950: "#0E1015";
            readonly 900: "#171A21";
            readonly 875: "#1B1F27";
            readonly 850: "#21242C";
            readonly 825: "#252932";
            readonly 800: "#2A2E37";
            readonly 775: "#303540";
            readonly 750: "#383D47";
            readonly 725: "#3D424D";
            readonly 700: "#454954";
            readonly 675: "#4C505C";
            readonly 600: "#5D626F";
            readonly 500: "#747B8B";
            readonly 400: "#A1A5B0";
            readonly 300: "#B2B7C3";
            readonly 200: "#C5C9D3";
            readonly 100: "#DFE2E7";
            readonly 50: "#EBEFF0";
        };
        green: {
            readonly 950: "#032117";
            readonly 900: "#053827";
            readonly 850: "#074F37";
            readonly 800: "#0A6B4A";
            readonly 700: "#0F996A";
            readonly 600: "#13C386";
            readonly 500: "#17E8A0";
            readonly 400: "#3CECAF";
            readonly 300: "#6AF1C2";
            readonly 200: "#99F5D5";
            readonly 100: "#C7FAE8";
            readonly 50: "#F1FEF9";
        };
        yellow: {
            readonly 950: "#242000";
            readonly 900: "#3D2F00";
            readonly 850: "#574500";
            readonly 800: "#756200";
            readonly 700: "#A88C00";
            readonly 600: "#D6BA00";
            readonly 500: "#FFE500";
            readonly 400: "#FFEB33";
            readonly 300: "#FFF170";
            readonly 200: "#FFF59E";
            readonly 100: "#FFF9C2";
            readonly 50: "#FFFEF0";
        };
        red: {
            readonly 950: "#130205";
            readonly 900: "#200308";
            readonly 850: "#38060E";
            readonly 800: "#660A19";
            readonly 700: "#8B0E23";
            readonly 600: "#BA1239";
            readonly 500: "#E81748";
            readonly 400: "#E95374";
            readonly 300: "#F2788D";
            readonly 200: "#F599A8";
            readonly 100: "#FAC7D0";
            readonly 50: "#FFF0F2";
        };
        purple: {
            readonly 950: "#020318";
            readonly 900: "#030530";
            readonly 850: "#050847";
            readonly 800: "#070A5F";
            readonly 700: "#0A0F8F";
            readonly 600: "#0D14BF";
            readonly 500: "#111AEE";
            readonly 400: "#4A51F2";
            readonly 350: "#5D63F4";
            readonly 300: "#747AF6";
            readonly 200: "#9FA3F9";
            readonly 100: "#CFD1FC";
            readonly 50: "#F1F1FE";
        };
    };
};
